      SUBROUTINE GGANAL(IC)
*     ====================
*
* *********************************************************************
*
*   User analysis of an event
*
***********************************************************************
*
C in  IC  -2 Data cards initializationin
C         -1 User initialization before event generation loop
C          0 Event analysis called after each generated event
C          1 Book keeping called after the end of generation loop
C out IC   0 event accepted
C            At least one jet verify the user defined conditions on PRMA
c            PTMA, PZMA, RNMA and acceptance.
C The jetset common LUJETS is edited (modified) according to the
C user defined acceptance and energy (or momentum) thresholds
c  
C D. Perret-Gallix 22/11/95
      double precision WGHT0,FAIL,WGHT,ACCPTX
      COMMON/QCWGHT/ WGHT0,FAIL,WGHT,ACCPTX
      double precision ZINV
      COMMON/COND/ICOND,IDEVT(3),NEVNT,ZINV
      integer K(4000,5)
      REAL*4 P(4000,5),V(4000,5)
      COMMON/LUJETS/N,K,P,V 
      COMMON/USCUT1/THCMIN,GEMIN,PCMIN,THNMIN,ENMIN,PRJMAX,PTJMAX
      COMMON/USCUT2/PTMAX,PZMAX,RMMAX
      DIMENSION PP(5)
      COMMON/TEMP/ICD2,ICD3

      IF (IC) 1, 1000, 5000
*
    1 IF (IC.EQ.-2) THEN
*
* *** Define HBOOK memory

      ELSEIF (IC.EQ.-1) THEN
       CTHCMIN=COS(THCMIN)
       CTHNMIN=COS(THNMIN)
*
* ***  INITIALIZE THE HISTOGRAMS
*
       CALL HBOOK1(1,"luexe error",10,0.,10.,0.)
       CALL HBOOK1(10,"NB OF F.S. PART.",100,0.,100.,0.)
       CALL HBOOK1(11,"NB OF F.S. PART. IN ACCEPT",100,0.,100.,0.)
       CALL HBOOK1(20,"PARTICLE PT",100,0.,40.,0.)
       CALL HBOOK1(30,"PARTICLE INVARIANT MASS",100,0.,60.,0.)
       CALL HBOOK1(40,"PS-RAP",100,-5.,+5.,0.)
       CALL HBOOK1(50,"gamma-gamma INVARIANT MASS",100,0.,60.,0.)
       CALL HBOOK1(110,"NUMBER OF JETS",22,-2.,20.,0.)
       CALL HBOOK1(120,"JET PT",100,0.,60.,0.)
       CALL HBOOK1(121,"JET PT PTCUT",100,0.,60.,0.)
       CALL HBOOK1(122,"JET PT PTCUT PZCUT",100,0.,60.,0.)
       CALL HBOOK1(123,"JET PT PTCUT PZCUT RMCUT",100,0.,60.,0.)

       CALL HBOOK1(130,"JET INVARIANT MASS",100,0.,60.,0.)
       CALL HBOOK1(140,"PS-RAP JET",100,-5.,5.,0.)
       CALL HBOOK1(141,"PS-RAP JET PTCUT",100,-5.,5.,0.)
       CALL HBOOK1(142,"PS-RAP JET PTCUT PZCUT",100,-5.,5.,0.)
       CALL HBOOK1(143,"PS-RAP JET PTCUT, PZCUT, RMCUT",100,-5.,5.,0.)
       CALL HBOOK1(150,"JET PT PSRAP",100,0.,60.,0.)
       CALL HBOOK1(151,"JET PT PTCUT, PSRAP",100,0.,60.,0.)
       CALL HBOOK1(152,"JET PT PTCUT PZCUT PSRAP",100,0.,60.,0.)
       CALL HBOOK1(153,"JET PT PTCUT PZCUT RMCUT PSRAP",100,0.,60.,0.)
       CALL HBOOK1(160,"PS-RAP JET PSRAP",100,-5.,+5.,0.)
       CALL HBOOK1(161,"PS-RAP JET PTCUT PSRAP",100,-5.,5.,0.)
       CALL HBOOK1(162,"PS-RAP JET PTCUT PZCUT PSRAP",100,-5.,5.,0.)
       CALL HBOOK1(163,"PS-RAP JET PTCUT PZCUT RMCUT PSRAP",
     &                 100,-5.,5.,0.)
       CALL LUGIVE('MSTU(54)=3')
       ICD2=IDIGIT(ICOND,2) 
       ICD3=IDIGIT(ICOND,3) 
      ENDIF
      RETURN
*
 1000 CONTINUE
*
*     ANALYSIS
*
*      Set the weight according to the user taste
*
      RW=1.
      IF(ICD3.EQ.1) RW=SNGL(WGHT)
*
*      Set a priori rejection
*
      IC=1
*
*      Invariant mass (gamma-gamma)
*     
      R=(P(1,4)-P(3,4)+P(2,4)-P(4,4))**2
     + -(P(1,3)-P(3,3)+P(2,3)-P(4,3))**2
      IF(R.GE.0.) THEN
       R=SQRT(R)
      ELSE
       R=-1.
      ENDIF
      CALL HFILL(50,R,0.,RW)
*
*     Kill particles not physical
*
      CALL LUEDIT(2)
      CALL HFILL(10,FLOAT(N),0.,RW)
*
*     Check acceptance
*
      DO I=1,N
       PA=SQRT(P(I,1)*P(I,1)+P(I,2)*P(I,2)+P(I,3)*P(I,3))
       CTH=1.
       IF(PA.GT.0.0)THEN 
        CTH=P(I,3)/PA 
       ENDIF
       KT=ABS(K(I,2))
       IF(K(I,2).EQ.22.OR.KT.EQ.11) THEN
        IF(P(I,4).LT.GEMIN.OR.ABS(CTH).GT.CTHCMIN) THEN 
         K(I,1)=0
        ENDIF
       ELSEIF(KT.EQ.12) THEN
        IF(PA.LT.PCMIN.OR.ABS(CTH).GT.CTHCMIN) THEN 
         K(I,1)=0
        ENDIF
       ELSEIF(LUCHGE(K(I,2)).NE.0)THEN 
        IF(PA.LT.PCMIN.OR.ABS(CTH).GT.CTHCMIN) THEN 
         K(I,1)=0
        ENDIF
       ELSE
        IF(P(I,4).LT.ENMIN.OR.ABS(CTH).GT.CTHNMIN) THEN 
         K(I,1)=0
        ENDIF 
       ENDIF
      ENDDO
*
*      Kill particles not in aCceptance
*                  
      CALL LUEDIT(2)
      IF(N.EQ.0) RETURN
      IF(ICD2.EQ.1) IC=0
*
*     Compute pt, pseudo-rapidity, invariant mass
*
      CALL HFILL(11,FLOAT(N),0.,RW)
      PX=0.
      PY=0.
      PZ=0.
      ET=0.
      DO I=1,N
       PP(1)=P(I,1)
       PP(2)=P(I,2)
       PP(3)=P(I,3)
       PP(4)=P(I,4)
       PT=SQRT(PP(1)*PP(1)+PP(2)*PP(2))
       PA=SQRT(PP(1)*PP(1)+PP(2)*PP(2)+PP(3)*PP(3))
       CALL HFILL(20,PT,0.,RW)
       CTH=1.
       IF(PA.GT.0.0)THEN 
        CTH=PP(3)/PA 
       ENDIF
       PSRAP=-LOG(TAN(ACOS(CTH)/2.0))
       CALL HFILL(40,PSRAP,0.,RW)
       ET=ET+PP(4)
       PX=PX+PP(1)
       PY=PY+PP(2)
       PZ=PZ+PP(3)
      ENDDO
      PT=SQRT(PX*PX+PY*PY)
      RM=ET*ET-PX*PX-PY*PY-PZ*PZ
      IF(RM.GE.0.) THEN
       RM=SQRT(RM)
       CALL HFILL(30,RM,0.,RW)
      ENDIF
*
*      look for jets
*
      CALL LUCELL(NJET)
      CALL HFILL(110,FLOAT(NJET),0.,RW)
      IF(NJET.EQ.0) RETURN
      IF(ICD2.EQ.2) IC=0

      PXJ=0.
      PYJ=0.
      PZJ=0.
      ETJ=0.
      DO I=1,NJET
       IN=N+I
       PP(1)=P(IN,1)
       PP(2)=P(IN,2)
       PP(3)=P(IN,3)
       PP(4)=P(IN,4)
       PTJ=SQRT(PP(1)*PP(1)+PP(2)*PP(2))
       PA=SQRT(PP(1)*PP(1)+PP(2)*PP(2)+PP(3)*PP(3))
       CALL HFILL(120,PTJ,0.,RW)
       CTH=1.
       IF(PA.GT.0.0)THEN 
        CTH=PP(3)/PA 
       ENDIF
       PSRAP=-LOG(TAN(ACOS(CTH)/2.0))
       CALL HFILL(140,PSRAP,0.,RW)
       IF(ABS(PSRAP).LT.PRJMAX) THEN
        CALL HFILL(150,PTJ,0.,RW)
        CALL HFILL(160,PSRAP,0.,RW)
        IF(PTJ.LT.PTJMAX) THEN
         IF(ICD2.EQ.3) IC=0
        ENDIF
       ENDIF
       IF(PT.LT.PTMAX) THEN
        CALL HFILL(121,PTJ,0.,RW)
        CALL HFILL(141,PSRAP,0.,RW)
        IF(ABS(PSRAP).LT.PRJMAX) THEN
         CALL HFILL(151,PTJ,0.,RW)
         CALL HFILL(161,PSRAP,0.,RW)
        ENDIF
        IF(PZ.LT.PZMAX) THEN
         CALL HFILL(122,PTJ,0.,RW)
         CALL HFILL(142,PSRAP,0.,RW)
         IF(ABS(PSRAP).LT.PRJMAX) THEN
          CALL HFILL(152,PTJ,0.,RW)
          CALL HFILL(162,PSRAP,0.,RW)
         ENDIF
         IF(RM.LT.RMMAX) THEN
          CALL HFILL(123,PTJ,0.,RW)
          CALL HFILL(143,PSRAP,0.,RW)
          IF(ABS(PSRAP).LT.PRJMAX) THEN
           CALL HFILL(153,PTJ,0.,RW)
           CALL HFILL(163,PSRAP,0.,RW)
           IF(PTJ.LT.PTJMAX) THEN
            IF(ICD2.EQ.4) IC=0
           ENDIF
          ENDIF
         ENDIF
        ENDIF
       ENDIF
       ETJ=ETJ+PP(4)
       PXJ=PXJ+PP(1)
       PYJ=PYJ+PP(2)
       PZJ=PZJ+PP(3)
      ENDDO
      RMJ=ETJ*ETJ-PXJ*PXJ-PYJ*PYJ-PZJ*PZJ
      IF(RMJ.GE.0.) THEN
       RMJ=SQRT(RMJ)
       CALL HFILL(130,RMJ,0.,RW)
      ENDIF

      RETURN

 5000 CONTINUE
*
* *** Print Statistics
*
      RETURN
      END
