      SUBROUTINE LAMB
c LAMBDA_qcd is defined for a given number of flavor.
c User defined FLAMD and NFLAV are compared with the World Average value of
c NFLAV=5 FLAMD=195 MeV
C Initial value are NOT modified unless one of them has been set to 0
c see Phys. Rev. D 50 1297
c D. Perret-Gallix 22 Nov 1995

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/QCPAR/ROOTS,Q2MAX,Q02,Q2MIN,FLAMD,QMASS(10),NFLAV
      DIMENSION RMQ(5)
      DATA RMQ/0.005D0,0.010D0,0.2D0,1.3D0,4.3D0/
      EXTERNAL LAMBDA
      print *,'  '
      print *,'******    Lambda QCD Check  (start) ****** '
      print *,'  '
      IF(NFLAV.EQ.0.OR.FLAMD.EQ.0.D0) THEN 
       NFLAV=5
       FLAMD=195.D-3
       PRINT *,'NFLA OR LAMB NOT DEFINED: SET TO WORLD AVERAGE VALUES:'
      ELSEIF(NFLAV.LT.5) THEN
       RL=FLAMD
       LL=NFLAV
       DO I=LL,5
        CALL LAMBDA(RMQ(I),I,RL)
       ENDDO
       PRINT *,'NFLA = ',NFLAV,' LAMB = ',FLAMD,
     &                                    ' SET BY USER, GIVES FOR'
       PRINT *,'NFLA = ',5,' LAMB = ',RL,
     &              ' TO BE COMPARED WITH THE WORLD AVERAGE VALUES'
      ELSEIF(NFLAV.EQ.5) THEN
       PRINT *,'NFLA = ',NFLAV,' LAMB = ',FLAMD
       PRINT *,' TO BE COMPARED WITH THE WORLD AVERAGE VALUES'
      ENDIF
       PRINT *,'NFLA =  5 LAMB = 0.195 GEV'
      print *,'  '
      print *,'******    Lambda QCD Check (end)   ****** '
      print *,'  '
      RETURN
      END

      SUBROUTINE LAMBDA(RMQ,NFLAV,FLAMD)
      IMPLICIT REAL*8(A-H,O-Z)
      EXTERNAL B0,B1,B2
      RL=DLOG((RMQ/FLAMD)**2)
      RF=DBLE(FLOAT(NFLAV))
      RF1=RF-1.D0
      BB=B1(RF)/B0(RF)-B1(RF1)/B0(RF1)
      BB1N =2.D0*B1(RF) /B0(RF)
      BB1N1=2.D0*B1(RF1)/B0(RF1)
      BB2N =2.D0*B2(RF) /B0(RF)
      BB2N1=2.D0*B2(RF1)/B0(RF1)
      R = (B0(RF)-B0(RF1))*RL
     &   + 2.D0*BB*DLOG(RL)       
     &   - 2.D0*B1(RF1)/B0(RF1)*DLOG(B0(RF)/B0(RF1))
     &   + (4.D0*B1(RF)/B0(RF)**2*BB*DLOG(RL))/RL
     &   + (1.D0/B0(RF)*(BB1N**2-BB1N1**2-BB2N+BB2N1-14.D0/9.D0))/RL
      FLAMD=DSQRT(DEXP(R/B0(RF1)))*FLAMD
      NFLAV=NFLAV+1
      RETURN
      END
      DOUBLE PRECISION FUNCTION B0(RFLAV)
      IMPLICIT REAL*8(A-H,O-Z)
      B0=11.D0-2.D0/3.D0*RFLAV
      RETURN
      END
      DOUBLE PRECISION FUNCTION B1(RFLAV)
      IMPLICIT REAL*8(A-H,O-Z)
      B1=51.D0-19.D0/3.D0*RFLAV
      RETURN
      END
      DOUBLE PRECISION FUNCTION B2(RFLAV)
      IMPLICIT REAL*8(A-H,O-Z)
      B2=2857.D0-5033.D0/9.D0*NFLAV -325.D0/27.D0*RFLAV*RFLAV
      RETURN
      END
