      SUBROUTINE LUND (MODE)
C         partn(1, ):  internal use, neglect this value
C         partn(2, ):  internal use, neglect this value
C         partn(3, ):  internal use, neglect this value
C         partn(4, ):  x-component of the four momentum
C         partn(5, ):  y-component of the four momentum
C         partn(6, ):  z-component of the four momentum
C         partn(7, ):  E-component of the four momentum
C         partn(8, ):  internal use, neglect this value
C         partn(9, ):  internal use, neglect this value
c
C         listp(1, ): particle ID
C                    1,2,3,4,5,6:u-,d-,s-,c-,b-,t-quark
c                    negative ; antiquark
C                    0 : gluon
c                    22 : photon
c                    11 : electron
c                   -11 : positron
c
C         listp(2, ):  internal use, neglect this value
C         listp(3, ):  number of  children
C         listp(4, ):  internal use, neglect this value
C         listp(5, ):  internal use, neglect this value
C         listp(6, ):  spacelike(-1) or timelike(+1)
c                      -2 initial electron/positron 2 final electron/positron
c
c 
c      Arry "listp" of final particles is
c 
c         listp(3, )  = 0
c         listp(6, )  > 0.
c 
c         The number "NTOP" is the maximum size of the array "partn",
c         "listp".
c 
c         As noticed before,   each event has a weight, which is
c         stored as "wght" in common.
c 
c     common/qcwght/wght0,fail,wght,accptx
 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /QCEVNT/ PARTN(10,1000),LISTP(10,1000),NTOP
      COMMON /COLOR/ CF,CA,TR,PI,BETA0
      COMMON /QCPAR/ ROOTS,Q2MAX,Q02,Q2MIN,FLAMD,QMASS(10),NFLAV
      COMMON /QCWGHT/ WGHT0,FAIL,WGHT,ACCPTX
      COMMON /PRCSS/ ECM,XBMIN,NPRC
      COMMON /PHOTON/ ALPHA,RTX,RTPH,RTVM,NFL,NFVM
      COMMON /CXXXX/ ACCEPT,NCOUNT,NACCPT,NBIN,NAWGT
      COMMON /AXXXX/ XBIN(10,100),YBIN(-4:4,10,100),DX(10)
      COMMON /BXXXX/ XSUM(-4:4),PRFRA(10)
      INTEGER K(4000,5)
      REAL*4 P(4000,5),V(4000,5)
      COMMON/LUJETS/N,K,P,V
      REAL*4 PARU,PARJ
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      DIMENSION IE(4),IP(1000),IPP(1000)
      COMMON/CLRSTR/NSTR,KSTR(100),LSTR(100),MSTR(100),NASTR(100)
      COMMON/UWGHT/WGHTMAX,WGHTMMAX,WGHTO,NIN,NOUT,NTOT,NLW,NLUEXE 
      COMMON/COND/ICOND,IDEVT(3),NEVNT,ZINV 
      REAL*4 ULMASS

      IF (MODE) 1, 1000, 5000
1     CONTINUE
      NLUEXE=0
   
C Lund parameter initialization
C 
C MSTU(21) = 2    : Error checking
c       CALL LUGIVE('MSTU(21)=1')
C MSTU(22) = 10   : Maximun nb of error to be printed and before stop
c       CALL LUGIVE('MSTU(22)=100')
C PARJ(81) = 0.29 : Lambda QCD
      print *,"Lambda QCD Default in jetset             = ",PARJ(81)
      PARJ(81)=SNGL(FLAMD)
      print *,"Lambda QCD used    in jetset             = ",PARJ(81)
C MSTU(112)= 5 Number of flavor in computing alpha s
      print *,"Nber of favors default in jetset         = ",MSTU(112)
      MSTU(112)=NFLAV
      print *,"Nber of favors used    in jetset         = ",MSTU(112)
      RETURN

1000  CONTINUE
c initialization
      NPTCL=0
      N=0
      DO I=1,4
       IE(I)=0
      ENDDO
C Loop over the list
      DO I=1,NTOP
       IF (LISTP(6,I).EQ.-2) THEN
        IF(LISTP(1,I).EQ.11) THEN
C          INITIAL ELECTRON 
         IE(1)=I
         K(1,3)=0
        ELSE
         K(2,3)=0
         IE(2)=I
        ENDIF
       ENDIF    
       IF (LISTP(6,I).EQ.2) THEN
        IF(LISTP(1,I).EQ.11) THEN
C          SCATTERRED ELECTRON 
         IE(3)=I
         K(3,3)=1
        ELSE
         IE(4)=I
         K(4,3)=2
        ENDIF
       ENDIF
       IF (LISTP(6,I).EQ.1.AND.LISTP(3,I).EQ.0) THEN
C Number of stable particles
        NPTCL=NPTCL+1
        IP(I)=4+NPTCL
C Momentum and energy
        P(4+NPTCL,1)=SNGL(PARTN(4,I))
        P(4+NPTCL,2)=SNGL(PARTN(5,I))
        P(4+NPTCL,3)=SNGL(PARTN(6,I))
        P(4+NPTCL,4)=SNGL(PARTN(7,I))
C particle type
        IF(ABS(LISTP(1,I)).EQ.1)K(4+NPTCL,2)=SIGN(2,LISTP(1,I))
        IF(ABS(LISTP(1,I)).EQ.2)K(4+NPTCL,2)=SIGN(1,LISTP(1,I))
        IF(ABS(LISTP(1,I)).EQ.3)K(4+NPTCL,2)=LISTP(1,I)
        IF(ABS(LISTP(1,I)).EQ.4)K(4+NPTCL,2)=LISTP(1,I)
        IF(ABS(LISTP(1,I)).EQ.5)K(4+NPTCL,2)=LISTP(1,I)
        IF(ABS(LISTP(1,I)).EQ.6)K(4+NPTCL,2)=LISTP(1,I)
        IF(LISTP(1,I).EQ.0)K(4+NPTCL,2)=21
        IF(LISTP(1,I).EQ.22)K(4+NPTCL,2)=22
        IF(ABS(LISTP(1,I)).EQ.11)K(4+NPTCL,2)=LISTP(1,I)
c mass
        P(4+NPTCL,5)=ULMASS(K(4+NPTCL,2))
c status
        K(4+NPTCL,1)=3
c parent
        K(4+NPTCL,3)=0
       ENDIF
      ENDDO

c initial particles and final e-p
C Momentum and energy
      DO I=1,4
       DO J=1,4
        P(I,J)=SNGL(PARTN(3+J,IE(I)))
       ENDDO
C particle type
       IF(ABS(LISTP(1,IE(I))).EQ.1)K(I,2)=SIGN(2,LISTP(1,IE(I)))
       IF(ABS(LISTP(1,IE(I))).EQ.2)K(I,2)=SIGN(1,LISTP(1,IE(I)))
       IF(ABS(LISTP(1,IE(I))).EQ.3)K(I,2)=LISTP(1,IE(I))
       IF(ABS(LISTP(1,IE(I))).EQ.4)K(I,2)=LISTP(1,IE(I))
       IF(ABS(LISTP(1,IE(I))).EQ.5)K(I,2)=LISTP(1,IE(I))
       IF(ABS(LISTP(1,IE(I))).EQ.6)K(I,2)=LISTP(1,IE(I))
       IF(LISTP(1,IE(I)).EQ.0)K(I,2)=21
       IF(LISTP(1,IE(I)).EQ.22)K(I,2)=22
       IF(ABS(LISTP(1,IE(I))).EQ.11)K(I,2)=LISTP(1,IE(I))
c mass
       P(I,5)=ULMASS(K(I,2))
      ENDDO
c status
      K(1,1)=21
      K(2,1)=21
      K(3,1)=1
      K(4,1)=1
      N=4+NPTCL

c Check invariant gamma-gamma mass (this should be done earlier in
c the generation but on the meanwhile it is done here:
      R=(dble(P(1,4))-dble(P(3,4))+dble(P(2,4))-dble(P(4,4)))**2
     + -(dble(P(1,3))-dble(P(3,3))+dble(P(2,3))-dble(P(4,3)))**2

      IF(R.LT.ZINV**2) THEN
       MODE=11
       return
      ENDIF

c     CALL LULIST(1)
c arrange color flow
c
      IF(NSTR.NE.0) THEN
       DO I=1,NSTR
        DO J=1,LSTR(I)
         IPP(J)=IP(NASTR(MSTR(I)+J-1))
        ENDDO
        CALL LUJOIN(LSTR(I),IPP)
        DO J=1,LSTR(I)
         IPP(J)=0
        ENDDO
       ENDDO
      ENDIF
      CALL LUEXEC
      IF(MSTU(24).NE.0) THEN
       MODE=12
       NLUEXE=NLUEXE+1
       call hfill(1,float(mstu(24)),0.,1.)
      endif
      RETURN

5000  CONTINUE
C
      PRINT *,'      '
      PRINT *,'HADRONIZATION  STATISTICS' 
      PRINT *,' ' 
      PRINT *,'EVENT with LUEXEC ERROR  : ',NLUEXE 
      PRINT *,'      '
      PRINT *,'*************** END GGPS2 *****************************'
      RETURN
      END
