c-------------------------------------------------------------------
c     Main Program GGPS
c T. Munehisa, K.Kato, D. Perret-Gallix
C last correction 22 Nov 1995
C last correction 30 Jan 1996
c-------------------------------------------------------------------

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      COMMON/PRCSS/ECM,XBMIN,NPRC
      COMMON/QCWGHT/WGHT0,FAIL,WGHT,ACCPTX
      COMMON/QCPAR/ROOTS,Q2MAX,Q02,Q2MIN,FLAMD,QMASS(10),NFLAV
      COMMON/PHOTON/ALPHA,RTX,RTPH,RTVM,NFL,NFVM
      COMMON/CROSS/SIGMA0,SIGMAX,SIGMA
      COMMON/PRCGG/Q2XMAX,Q2XMIN,ZMIN,AME2,ECMX0
      COMMON/CLRSTR/NSTR,KSTR(100),LSTR(100),MSTR(100),NASTR(100) 
      COMMON/UWGHT/WGHTMAX,WGHTMMAX,WGHTO,NIN,NOUT,NTOT,NLW,NLUEXE 
      COMMON/COND/ICOND,IDEVT(3),NEVNT,ZINV
      COMMON/TEMP1/ICD1,ICD2,ICD3
      common/modegg/modeg,neven
      common/failxxx/faila,failr
      REAL*4 EF,OV,EL
c
c      Steps for generation of
c      virtual photon and real photon events in e+ e- process
 
c      step 1: pick up Q^2
c      step 2: pick up energy of real photon
c      step 3: make shower of electron and photon system
c      step 4: make boost of Lab. system
c
 
      CALL USINIT(-2)
      CALL USINIT(-1)
      ICD1=IDIGIT(ICOND,1)
      ICD2=IDIGIT(ICOND,2)
      ICD3=IDIGIT(ICOND,3)
 
c       subroutine for analysis
      MODE=0
      IF(IDEVT(1).LT.0) MODE=1
      CALL QCPREP(MODE)
      CALL ANAL(-1)
      CALL USANAL(-1)
      IF(ICD3.EQ.0)CALL UNWGHT(-1)
      CALL LUND(-1)
      CALL USLUND(-1)
      WGHT0 =0.0D0
      FAIL = 0.0D0
      FAILM = 0.0D0
      FAILU = 0.0D0
      FAILa = 0.0D0
      FAILr = 0.0D0
      NSTEP=IFIX(NEVNT/IDEVT(3))
      II=0

C
      DO  I=1,NEVNT
   10  CONTINUE
c
c   Generate an event
      call ggpsgo(nfail) 
      if( nfail.eq.1 ) then
          fail = fail + 1.0d0
          faila = faila + 1.0d0
          go to 10
      end if
c
       IF(ICD3.EQ.0) THEN 
        IC=0
        CALL UNWGHT(IC)
        IF(IC.GE.10) then
C        OVERWEIGHT EVENTS ic=10 
C        EVENTS REJECTED DUE TO UNWGHTING PROCEDURE ic=11 
         FAIL = FAIL + 1.0D0
         FAILr = FAILr + 1.0D0
         GOTO 10
        ENDIF
       ENDIF
C
       MODE = 0
       IPRT = 0
c      IF(I .GE. ABS(IDEVT(1)).and.I.LE.IDEVT(2)) IPRT = 1
       CALL MKSTR3(MODE,IPRT,NSTR,KSTR,LSTR,MSTR,NASTR,NRET)
       IF(NRET .EQ. 1)WRITE(6,*)'MKSTR3: Error in the color flow'
 
c       subroutine for analysis
       CALL ANAL(0)
       CALL USANAL(0)
       IC=0
       CALL LUND(IC)
C  ic=12 failure of luexec
c  ic=11 mass invariant gammagamma below treshold (temporary) 
       IF(IC.GE.10) then
        FAILM = FAILM + 1.0D0
        GOTO 10
       ENDIF
       IF(I.GE.ABS(IDEVT(1)).AND.I.LE.IDEVT(2).AND.
     &    II.LT.(IDEVT(2)-ABS(IDEVT(1))))THEN
c        CALL QCLIST
c        WRITE(6,20)WGHT
        CALL LULIST(1)
        II=II+1
       ENDIF
       IC=0
       CALL USLUND(IC) 
       IF(IC.NE.0.AND.ICD2.GT.0) THEN
C       USER REJECTION
        FAILU = FAILU + 1.0D0
        GOTO 10
       ENDIF
C...Convert to the /HEPEVT/ common block  iF needed
       IF(ICD1.EQ.1) CALL LUHEPC(1)

       IF(I .EQ. IDEVT(2)+1)THEN
        PRINT *,' '
        PRINT *,'****************************************************'
        PRINT *,'                RUNNING STATISTICS '
        PRINT *,'****************************************************'
        PRINT *,' '
        PRINT *,' NB. OF EVENT REQUESTED : ', NEVNT
        PRINT *,' '
        IF(ICD3.EQ.1) WRITE(6,102)
       ENDIF

       IF(MOD(I,NSTEP) .EQ. 0) THEN
        IF(ICD3.EQ.1) THEN
         WRITE(6,101) I,IFIX(FAIL+FAILM+FAILU),
     &                  IFIX(FAIL),IFIX(FAILM),IFIX(FAILU)
        ELSE
         EF=FLOAT(NIN)/FLOAT(NTOT)*100
         OV=FLOAT(NLW)/FLOAT(NTOT)*100
         EL=FLOAT(NLUEXE)/FLOAT(NTOT)*100
         WRITE(6,100) I,EF,OV,EL
        ENDIF
       ENDIF   
       WGHT0  = WGHT0  + WGHT
      ENDDO

      PRINT *,' '
      WRITE(6,40) 
      IF(ICD3.EQ.1) THEN
       WRITE(6,102)
       WRITE(6,101) NEVNT,IFIX(FAIL+FAILM+FAILU),
     &                    IFIX(FAIL),IFIX(FAILM),IFIX(FAILU)
       SIGMA = SIGMAX*WGHT0/(FLOAT(NEVNT)+FAIL)
       WRITE(6,51) SIGMA
      ELSE
       SIGMA1= SIGMAX*wghtmax*float(NEVNT)/(float(NEVNT)+fail)
       SIGMA2= SIGMAX*wghtmax*(NEVNT+WGHTO)/(float(NEVNT)+fail)
       SIGMA = SIGMA2
       SIG=ABS(SIGMA1-SIGMA2)
       WRITE(6,52)
       WRITE(6,53)
       WRITE(6,54) SIGMA1,SIGMA2,SIG,SIG/SIGMA2*100.d0
c
       write(6,201)fail,faila,failr
 201  format(' fail#=',g20.10,'fail# due to ps,weight=',2G20.10)
      ENDIF 
      IF(FAILM.NE.0.D0) THEN
       SIGMAA= SIGMA*FLOAT(NEVNT)/(FLOAT(NEVNT)+FAILM)
       WRITE(6,55) SIGMAA 
      ENDIF          
      IF(FAILU.NE.0.D0) THEN
       SIGMAA= SIGMA*FLOAT(NEVNT)/(FLOAT(NEVNT)+FAILU)
       WRITE(6,56) SIGMAA 
      ENDIF 
      IF(FAILM.NE.0.D0.AND.FAILU.NE.0D0) THEN
       SIGMAA= SIGMA*FLOAT(NEVNT)/(FLOAT(NEVNT)+FAILM+FAILU)
       WRITE(6,57) SIGMAA 
      ENDIF             

      CALL ANAL(1)
      CALL USANAL(1)
      IF(ICD3.EQ.0)CALL UNWGHT(1)
      CALL LUND(1)
      CALL USLUND(1)
      CALL USINIT(1)
      STOP
c   20 format(' wght =',G10.5)
  100 FORMAT(' EVT GENERATED: ',I8,' EFFICIENCY: ',F5.2,'% OVERWGHT: ',
     +        F5.2,'% LUEXE ERR.: ',F5.2,'%')
  102 FORMAT(48X,'Kinematics Inv.mass User cuts') 
  101 FORMAT(' EVT GENERATED: ',I8, ' EVT TESTED: ',I8,' (',3(X,I8),')') 
   40 FORMAT('***********  END OF GENERATION ********************')
   51 FORMAT(' XSECT  WEIGHTED (pb)             : ',G10.5)
   52 FORMAT('            ','WEIGHTED      WEIGHTED    ERROR       %') 
   53 FORMAT('            ','NO OVERWEIGHT INCL. OVERW') 
   54 FORMAT(' XSECT (pb) ',4(G10.5,3x))
   55 FORMAT(' XSECT AFTER GG INV MASS CUT (pb) : ',G10.5)
   56 FORMAT(' XSECT AFTER USER CUTS       (pb) : ',G10.5)
   57 FORMAT(' XSECT AFTER ALL CUTS        (pb) : ',G10.5)
      END
