      SUBROUTINE UNWGHT(MODE)

C Unweighting  routine
c  Mode -1 initialization
c  Mode 0  called for each event
C  Mode 1  end of run printout
c return :
c  mode 10 overweight event
c  Mode 11 rejected due to randomization 
c D. Perret-Gallix Nov. 22 1995
 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /QCWGHT/ WGHT0,FAIL,WGHT,ACCPTX
      COMMON/UWGHT/WGHTMAX,WGHTMMAX,WGHTO,NIN,NOUT,NTOT,NLW,NLUEXE 
      COMMON/CROSS/  SIGMA0,SIGMAX,SIGMA
      COMMON/UWGHTx/wg,wgm,wgm2,wgg

      IF (MODE) 1, 1000, 5000
1     CONTINUE
C Counter Initialization
      NTOT=0
      NIN=0
      NOUT=0
      NLW=0
      WGHTMMAX=0.d0 
      WG=0.d0
      WGM=0.d0 
      WGM2=0.D0
      WGG=0.d0
      WGHTO=0.D0
      RETURN

1000  CONTINUE
C 
C Unweighting the events
      NTOT=NTOT+1
      WGG=WGG+WGHT
      IF(WGHT.GT.WGHTMAX) THEN
       IF(WGHT.GT.WGHTMMAX) WGHTMMAX=WGHT
       NLW=NLW+1
       WGM=WGM+WGHT
       WGM2=WGM2+WGHT*WGHT
       WGHTO=WGHTO+ WGHT/WGHTMAX
       MODE=10
       RETURN
      ENDIF
      RWGHT=WGHT/WGHTMAX
      IF(RANDOM(1).GT.RWGHT) THEN
       MODE=11
       NOUT=NOUT+1
       RETURN
      ELSE
       NIN=NIN+1
      ENDIF
      WG=WG+WGHT
      RETURN

5000  CONTINUE
C
      WRITE(6,*),' '
      WRITE(6,*),'**************************************************'
      WRITE(6,*),' '
      WRITE(6,*),'UNWEIGHTING STATISTICS'
      WRITE(6,*),' '
      WRITE(6,*),'EVENT GENERATED          : ',NTOT
      WRITE(6,*),'EVENT ACCEPTED           : ',NIN
      IF(NTOT.NE.0) THEN
      WRITE(6,100),float(NIN)/float(NTOT)*100
      ENDIF
      WRITE(6,*),'EVENT REJECTED           : ',NOUT
      WRITE(6,*),'EVENT OVERWEIGHT         : ',NLW
      IF(NTOT.NE.0) THEN
      WRITE(6,110),float(NLW)/float(NTOT)*100.
      ENDIF
      WRITE(6,120),WGM/WGG*100.D0
      WRITE(6,130),SIGMA
      WRITE(6,140),SIGMA*WGM/WGG
      IF(NLW.NE.0) THEN
      WMM=WGM/FLOAT(NLW)
      WGM2M=WGM2/FLOAT(NLW)
      WRITE(6,150),WMM
      WRITE(6,160),DSQRT(WGM2M-WMM**2)
      ENDIF
      WRITE(6,170),WGHTMAX
      WRITE(6,180),WGHTMMAX 
      WRITE(6,*),'      '
      RETURN
100   FORMAT(' GENERATION EFFICIENCY (%): ',F6.2)
110   FORMAT(' EVENT OVERWEIGHT (%)     : ',F6.2)
120   FORMAT(' ERR. DUE TO OVERWEIGHT(%): ',F6.2)
130   FORMAT(' TOTAL CROSS-SECTION (pb) : ',E12.5)
140   FORMAT(' ERR. ON CROSS-SECTION pb): ',E12.5)
150   FORMAT(' MEAN OVERWEIGHT          : ',E12.5)
160   FORMAT(' SIGMA OVERWEIGHT         : ',E12.5)
170   FORMAT(' MAXIMUM WEIGHT ASSUMED   : ',E12.5)
180   FORMAT(' MAXIMUM WEIGHT SEEN      : ',E12.5)
      END
