      SUBROUTINE USANAL (MODE)
C User analysis of event before hadronization
C uses Hbook cernlib.
C D. Perret-Gallix Nov. 22 1995

C         partn(1, ):  internal use, neglect this value
C         partn(2, ):  internal use, neglect this value
C         partn(3, ):  internal use, neglect this value
C         partn(4, ):  x-component of the four momentum
C         partn(5, ):  y-component of the four momentum
C         partn(6, ):  z-component of the four momentum
C         partn(7, ):  E-component of the four momentum
C         partn(8, ):  internal use, neglect this value
C         partn(9, ):  internal use, neglect this value
c
C         listp(1, ): particle ID
C                    1,2,3,4,5,6:u-,d-,s-,c-,b-,t-quark
c                    negative ; antiquark
C                    0 : gluon
c                    22 : photon
c                    11 : electron
c                   -11 : positron
c
C         listp(2, ):  internal use, neglect this value
C         listp(3, ):  number of  children
C         listp(4, ):  internal use, neglect this value
C         listp(5, ):  internal use, neglect this value
C         listp(6, ):  spacelike(-1) or timelike(+1)
c                      -2 initial electron/positron 2 final electron/positron
c
c 
c      Arry "listp" of final particles is
c 
c         listp(3, )  = 0
c         listp(6, )  > 0.
c 
c         The number "NTOP" is the maximum size of the array "partn",
c         "listp".
c 
c         As noticed before,   each event has a weight, which is
c         stored as "wght" in common.
c 
c     common/qcwght/wght0,fail,wght,accptx
 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /QCEVNT/ PARTN(10,1000),LISTP(10,1000),NTOP
      COMMON /COLOR/ CF,CA,TR,PI,BETA0
      COMMON /QCPAR/ ROOTS,Q2MAX,Q02,Q2MIN,FLAMD,QMASS(10),NFLAV
      COMMON /QCWGHT/ WGHT0,FAIL,WGHT,ACCPTX
      COMMON /PRCSS/ ECM,XBMIN,NPRC
      COMMON /PHOTON/ ALPHA,RTX,RTPH,RTVM,NFL,NFVM
      COMMON /CXXXX/ ACCEPT,NCOUNT,NACCPT,NBIN,NAWGT
      COMMON /AXXXX/ XBIN(10,100),YBIN(-4:4,10,100),DX(10)
      COMMON /BXXXX/ XSUM(-4:4),PRFRA(10)
      REAL*4 PIM,r,r2,r10,SWGHT
      DATA PIM /3.14159E0/
      REAL*8 DPI,ME2
      DATA DPI,ME2/3.141592653589793238D0,0.71484198D0/

      IF (MODE) 1, 1000, 5000
1     CONTINUE
      r=sngl(roots)
      r2=r/2.
      r10=r/10.
      CALL HBOOK1 (2001 ,'Number of particle',30,0.,30.,0.)
      CALL HBOOK1 (2002 ,'total energy in jets',100,0.,r,0.)
      CALL HBOOK1 (2003 ,'energy in Gluons',100,0.,r2,0.)
      CALL HBOOK1 (2004 ,'energy in Quarks',100,0.,r2,0.)
      CALL HBOOK1 (2005 ,'energy in Gamma ',100,0.,r2,0.)
      CALL HBOOK1 (2006 ,'energy in electron ',100,0.,r2,0.)
      CALL HBOOK1 (2007 ,'particle type ',60,-30,30.,0.)
      CALL HBOOK1 (2008 ,'ptotx  norm',100,-1.,1.,0.)
      CALL HBOOK1 (2009 ,'ptoty  norm',100,-1.,1.,0.)
      CALL HBOOK1 (2010,'ptotz  norm',100,-1.,1.,0.)
      CALL HBOOK1 (2011,'ptot ',100,0.,r,0.)
      CALL HBOOK1 (2013,'PT in Gluons',100,0.,r10,0.)
      CALL HBOOK1 (2014,'PT in Quarks',100,0.,r10,0.)
      CALL HBOOK1 (2015,'PT in Gamma ',100,0.,r10,0.)
      CALL HBOOK1 (2016,'PT in electron ',100,0.,r10,0.)
      CALL HBOOK1 (2020,'weight ',100,0.,1.,0.)
      CALL HBOOK1 (2021,'weight ',100,0.,1000.,0.)
      CALL HBOOK1 (2033,'CTH in Gluons',100,-1,1.,0.)
      CALL HBOOK1 (2034,'CTH in Quarks',100,-1,1.,0.)
      CALL HBOOK1 (2035,'CTH in Gamma ',100,-1,1.,0.)
      CALL HBOOK1 (2036,'CTH in electron ',100,-1,1.,0.)
      CALL HBOOK1 (2043,'PH in Gluons',100,0.,2*PIM,0.)
      CALL HBOOK1 (2044,'PH in Quarks',100,0.,2*PIM,0.)
      CALL HBOOK1 (2045,'PH in Gamma ',100,0.,2*PIM,0.)
      CALL HBOOK1 (2046,'PH in electron ',100,0.,2*PIM,0.)
      CALL HBOOK1 (2053,'P in Gluons',100,0.,r2,0.)
      CALL HBOOK1 (2054,'P in Quarks',100,0.,r2,0.)
      CALL HBOOK1 (2055,'P in Gamma ',100,0.,r2,0.)
      CALL HBOOK1 (2056,'P in electron ',100,0.,r2,0.)
      CALL HBOOK1 (2063,'PX Gluons',100,-r2,r2,0.)
      CALL HBOOK1 (2064,'PX Quarks',100,-r2,r2,0.)
      CALL HBOOK1 (2065,'PX Gamma',100,-r2,r2,0.)
      CALL HBOOK1 (2066,'PX electron',100,-r2,r2,0.)
      CALL HBOOK1 (2073,'PY Gluons',100,-r2,r2,0.)
      CALL HBOOK1 (2074,'PY Quarks',100,-r2,r2,0.)
      CALL HBOOK1 (2075,'PY Gamma',100,-r2,r2,0.)
      CALL HBOOK1 (2076,'PY electron',100,-r2,r2,0.)
      CALL HBOOK1 (2083,'PZ Gluons',100,-r2,r2,0.)
      CALL HBOOK1 (2084,'PZ Quarks',100,-r2,r2,0.)
      CALL HBOOK1 (2085,'PZ Gamma',100,-r2,r2,0.)
      CALL HBOOK1 (2086,'PZ electron',100,-r2,r2,0.)
      CALL HBOOK1 (2100,'PX,TOTAL norm',100,-1.,1.,0.)
      CALL HBOOK1 (2101,'PY,TOTAL norm',100,-1.,1.,0.)
      CALL HBOOK1 (2102,'PZ,TOTAL norm',100,-1.,1.,0.)
      CALL HBOOK1 (2103,'E,TOTAL',100,0.,r+10.,0.)
      CALL HBOOK1 (2104,'P,TOTAL',100,0.,r+10.,0.)
      CALL HBOOK1 (2110,'Q2 ELECTRON',100,0.,r2**2,0.)
      CALL HBOOK1 (2111,'Q2 POSITRON',100,0.,r2**2,0.)
      RETURN

1000  CONTINUE

      NPTCL=0
      ETOT=0.D0
      EPTCL=0.D0
      PTOTX=0.D0
      PTOTY=0.D0
      PTOTZ=0.D0
      IE1=0
      IE2=0
      IP1=0
      IP2=0
      SWGHT=SNGL(WGHT)
      call hfill(2020,swght,0.,1.)
      call hfill(2021,swght,0.,1.)
      DO I=1,NTOP
       IF (LISTP(6,I).EQ.-2) THEN
        IF(LISTP(1,I).EQ.11) THEN
C          INITIAL ELECTRON 
         IE1=I
        ELSE
         IP1=I
        ENDIF
       ENDIF    
       IF (LISTP(6,I).EQ.2) THEN
        IF(LISTP(1,I).EQ.11) THEN
C          SCATTERRED ELECTRON 
         IE2=I
        ELSE
         IP2=I
        ENDIF
       ENDIF
       IF (LISTP(6,I).EQ.1.AND.LISTP(3,I).EQ.0) THEN
C Number of stable particles
        NPTCL=NPTCL+1
C Total energy
        EPTCL=EPTCL+PARTN(7,I)
C total Momentum
        PTOTX=PTOTX+PARTN(4,I)
        PTOTY=PTOTY+PARTN(5,I)
        PTOTZ=PTOTZ+PARTN(6,I)
C Momentum
        PP=DSQRT(PARTN(4,I)**2+PARTN(5,I)**2+PARTN(6,I)**2)
        PT=DSQRT(PARTN(4,I)**2+PARTN(5,I)**2)
C TH and PHI 
        IF (PP.GT.0.D0) THEN
         CTH=PARTN(6,I)/PP
         TH=DACOS(CTH)
        ELSE
         TH=DPI+1
        END IF
        IF(PARTN(5,I).eq.0.d0.and.PARTN(4,I).eq.0.d0) then
         ph=0.d0
        else
         PH= DATAN2(PARTN(5,I),PARTN(4,I))+(DPI-DSIGN(DPI,PARTN(5,I)))
        endif
        CALL HFILL (2007,FLOAT(LISTP(1,I)),0.,SWGHT)
        IF (LISTP(1,I).EQ.0) THEN
         CALL HFILL (2003,SNGL(PARTN(7,I)),0.,SWGHT)
         CALL HFILL (2013,SNGL(PT),0.,SWGHT)
         CALL HFILL (2033,SNGL(CTH),0.,SWGHT)
         CALL HFILL (2043,SNGL(PH),0.,SWGHT)
         CALL HFILL (2053,SNGL(PP),0.,SWGHT)
         CALL HFILL (2063,SNGL(PARTN(4,I)),0.,SWGHT)
         CALL HFILL (2073,SNGL(PARTN(5,I)),0.,SWGHT)
         CALL HFILL (2083,SNGL(PARTN(6,I)),0.,SWGHT)
        ELSE IF (ABS(LISTP(1,I)).EQ.11) THEN
         CALL HFILL (2006,SNGL(PARTN(7,I)),0.,SWGHT)
         CALL HFILL (2016,SNGL(PT),0.,SWGHT)
         CALL HFILL (2036,SNGL(CTH),0.,SWGHT)
         CALL HFILL (2046,SNGL(PH),0.,SWGHT)
         CALL HFILL (2056,SNGL(PP),0.,SWGHT)
         CALL HFILL (2066,SNGL(PARTN(4,I)),0.,SWGHT)
         CALL HFILL (2076,SNGL(PARTN(5,I)),0.,SWGHT)
         CALL HFILL (2086,SNGL(PARTN(6,I)),0.,SWGHT)
        ELSE IF (ABS(LISTP(1,I)).EQ.22) THEN
         CALL HFILL (2005,SNGL(PARTN(7,I)),0.,SWGHT)
         CALL HFILL (2015,SNGL(PT),0.,SWGHT)
         CALL HFILL (2035,SNGL(CTH),0.,SWGHT)
         CALL HFILL (2045,SNGL(PH),0.,SWGHT)
         CALL HFILL (2055,SNGL(PP),0.,SWGHT)
         CALL HFILL (2065,SNGL(PARTN(4,I)),0.,SWGHT)
         CALL HFILL (2075,SNGL(PARTN(5,I)),0.,SWGHT)
         CALL HFILL (2085,SNGL(PARTN(6,I)),0.,SWGHT)
        ELSE
         CALL HFILL (2004,SNGL(PARTN(7,I)),0.,SWGHT)
         CALL HFILL (2014,SNGL(PT),0.,SWGHT)
         CALL HFILL (2034,SNGL(CTH),0.,SWGHT)
         CALL HFILL (2044,SNGL(PH),0.,SWGHT)
         CALL HFILL (2054,SNGL(PP),0.,SWGHT)
         CALL HFILL (2064,SNGL(PARTN(4,I)),0.,SWGHT)
         CALL HFILL (2074,SNGL(PARTN(5,I)),0.,SWGHT)
         CALL HFILL (2084,SNGL(PARTN(6,I)),0.,SWGHT)
        END IF
       END IF
      END DO
      CALL HFILL (2001 ,FLOAT(NPTCL),0.,SWGHT)
      CALL HFILL (2002 ,SNGL(EPTCL),0.,SWGHT)
      IF(IE2.NE.0.AND.IP2.NE.0) THEN
       ETOT=EPTCL+PARTN(7,IE2)+PARTN(7,IP2)
       CALL HFILL (2103,SNGL(ETOT),0.,SWGHT)
      ENDIF
      PTOT=DSQRT(PTOTX**2+PTOTY**2+PTOTZ**2)
      CALL HFILL (2011,SNGL(PTOT),0.,SWGHT)
      IF(PTOT.NE.0.D0) THEN
       CALL HFILL (2008 ,SNGL(PTOTX/PTOT),0.,SWGHT)
       CALL HFILL (2009 ,SNGL(PTOTY/PTOT),0.,SWGHT)
       CALL HFILL (2010,SNGL(PTOTZ/PTOT),0.,SWGHT)
      ENDIF
      IF(IE2.NE.0.AND.IP2.NE.0) THEN
       PTOTX=PTOTX+PARTN(4,IP2)+PARTN(4,IE2)
       PTOTY=PTOTY+PARTN(5,IP2)+PARTN(5,IE2)
       PTOTZ=PTOTZ+PARTN(6,IP2)+PARTN(6,IE2)
       PTOT=DSQRT(PTOTX**2+PTOTY**2+PTOTZ**2)
      ENDIF
      CALL HFILL (2104,SNGL(PTOT),0.,SWGHT)
      IF(PTOT.NE.0.D0) THEN
       CALL HFILL (2100 ,SNGL(PTOTX/PTOT),0.,SWGHT)
       CALL HFILL (2101 ,SNGL(PTOTY/PTOT),0.,SWGHT)
       CALL HFILL (2102 ,SNGL(PTOTZ/PTOT),0.,SWGHT)
      ENDIF
      IF(IE2.NE.0.AND.IE1.NE.0) THEN
       QE2=2.D0*(PARTN(7,IE1)*PARTN(7,IE2)-
     *            PARTN(4,IE1)*PARTN(4,IE2)-
     *            PARTN(5,IE1)*PARTN(5,IE2)-
     *            PARTN(6,IE1)*PARTN(6,IE2))
     *     -2.D0*ME2
       IF(QE2.NE.0.D0)  CALL HFILL (2110 ,SNGL(QE2),0.,SWGHT)
      ENDIF
      IF(IP2.NE.0.AND.IP1.NE.0) THEN
       QP2=2.d0*(PARTN(7,IP1)*PARTN(7,IP2)-
     *            PARTN(4,IP1)*PARTN(4,IP2)-
     *            PARTN(5,IP1)*PARTN(5,IP2)-
     *            PARTN(6,IP1)*PARTN(6,IP2))
     *     -2.d0*ME2
       IF(QP2.NE.0.D0) CALL HFILL (2111 ,SNGL(QP2),0.,SWGHT)
      ENDIF         

      RETURN

5000  CONTINUE
      RETURN
      END
