      SUBROUTINE USINIT(IC)
C Initialization routine based on qcinpt and original main.
C
C uses the FFREAD cernlib package for input user defined data
C D. Perret-Gallix Nov. 22 1995
C /ggps1/usinit.f --> usinit.f   K.Kato 30 Jan. 1996

      DOUBLE PRECISION CF,CA,TR,PI,BETA0
      COMMON/COLOR/CF,CA,TR,PI,BETA0

      DOUBLE PRECISION ROOTS,Q2MAX,Q02,Q2MIN,FLAMD,QMASS
      COMMON/QCPAR/ROOTS,Q2MAX,Q02,Q2MIN,FLAMD,QMASS(10),NFLAV

      DOUBLE PRECISION ECM,XBMIN
      COMMON/PRCSS/ECM,XBMIN,NPRC

      COMMON/QCFLG/KZAP,NAO

      COMMON /QCRND/ NSEED

      DOUBLE PRECISION Q2XMAX,Q2XMIN,ZMIN,AME2,ECMX0,RTXMN,RTXX
      COMMON/PRCGG/Q2XMAX,Q2XMIN,ZMIN,AME2,ECMX0,RTXMN,RTXX
     
      COMMON/REMNAT/NREM

      DOUBLE PRECISION partn
      COMMON/QCEVNT/PARTN(10,1000),LISTP(10,1000),NTOP

      DOUBLE PRECISION WGHT0,FAIL,WGHT,ACCPTX
      COMMON/QCWGHT/WGHT0,FAIL,WGHT,ACCPTX


      DOUBLE PRECISION ALPHA,RTX,RTPO,RTPH,RTVM
      COMMON/PHOTON/ALPHA,RTX,RTPO,RTPH,RTVM,NFL,NFVM

      DOUBLE PRECISION SIGMA0,SIGMAX,SIGMA
      COMMON/CROSS/SIGMA0,SIGMAX,SIGMA

      DOUBLE PRECISION WTYPE,TYPE,BTYPE
      COMMON/PRCXX/WTYPE(20),TYPE(20),BTYPE(10)

      COMMON/HRDCRSS/NCRSS

      COMMON/POINT/LPOINT

      COMMON/ RSLVXX /NTYPE(10)

      DOUBLE PRECISION FTYPE
      COMMON/ FAILXX /FTYPE(10)

      DOUBLE PRECISION DIST
      COMMON/XDIST/DIST(10,50)

      DOUBLE PRECISION Z1,Z2
      COMMON/PHSPC/Z1,Z2

      COMMON/CLRSTR/NSTR,KSTR(100),LSTR(100),MSTR(100),NASTR(100) 

      COMMON/USCUT1/THCMIN,GEMIN,PCMIN,THNMIN,ENMIN,PRJMAX,PTJMAX
      COMMON/USCUT2/PTMAX,PZMAX,RMMAX

      DOUBLE PRECISION WGHTMAX,WGHTMMAX,WGHTO
      COMMON/UWGHT/WGHTMAX,WGHTMMAX,WGHTO,NIN,NOUT,NTOT,NLW,NLUEXE 
      DOUBLE PRECISION ZINV
      COMMON/COND/ICOND,IDEVT(3),NEVNT,ZINV

      common/modegg/modeg,neven

      DIMENSION IDEVTD(3)  
      character*80 pawfile
      CHARACTER PAWF(80),CHBK, CHNL
      equivalence (pawf(1), pawfile(1:1))
      PARAMETER (NHLIM=100000)
      COMMON/PAWC/HMEMOR(NHLIM)

      CHBK=' '
      CHNL='' 
      IF(IC) 1,1000,5000
1     CONTINUE
      IF(IC.EQ.-2) THEN
      CALL HLIMIT(NHLIM)
      PRINT *,'         ',
     +'*******************************************************'
      PRINT *,'         ',
     +'*                  GGPS  EVENT GENERATOR              *'
      PRINT *,'         ',
     +'*                                                     *'
      PRINT *,'         ',
     +'*  Parton shower for two photon process               *'
      PRINT *,'         ',
     +'*                                                     *'
      PRINT *,'         ',
     +'* Authors: T. Munehisa, K. Kato, D. Perret-Gallix     *'
      PRINT *,'         ',
     +'* E-mail: munehisa@hep.esb.yamanashi.ac.jp            *'
      PRINT *,'         ',
     +'*         kato@sin.kogakuin.ac.jp                     *'
      PRINT *,'         ',
     +'*         perretg@cernvm.cern.ch                      *'
      PRINT *,'         ',
     +'* REF.  : T. Munehisa, P. Aurenche, J.Ph. Guillet,    *'
      PRINT *,'         ',
     +'*          M. Fontannaz and Y. Shimizu,               *'
      PRINT *,'         ',
     +'* KEK CP-034, KEK preprint 95-51, ENSLAPP-A-522/95,   *'
      PRINT *,'         ',
     +'* LPTHE-Orsay 95/37, to appear in  Z. Phys. C         *'
      PRINT *,'         ',
     +'*******************************************************'

C INITIALIZE THE PARAMETERS
      CALL FFINIT(0)
*
* *** Default values
*
c
c      Select event type
c      1 : Deep-inelastic scattering
c      2 : Quasi-real photon-photon scattering
       modeg = 0
c          initial seed of random number
c          function random(1): generator of random number
c      NSEED = 9876543
c
       NSEED=12345678
       IDEVT(1)=-1
       IDEVT(2)=10
       NEVNT=1000
       IDEVT(3)=10
       ICOND=0
c
c       choice of process
c      0 : calculate parton distributions in photon.
c      1 : process of real photon and electron scattering
c      2 : process of virtual photon and real photon
c          of electron positron scattering
c      nprc = 2

       NPRC=2
       NFLAV=4
c      renmant of the photon with emitting a gluon is
c      quark-antiquark pair
C      NREM = 1
c      it is gluon
c      NREM  = 0
 
       NREM=1
c
       LPOINT =0
C      LPOINT =1  RESTRICT ONE PHOTON IS POINT-LIKE 
C      LPOINT =2 RESTRICT TWO PHOTONS ARE POINT-LIKE 

       BMENER=90.
       RQ2MIN=10.0
       RM2MIN=0.25
       RQ2CUT=0.1
       RLAMB=0.23
       RZINV=0.0D0
c
       PTMAX=10.
       PZMAX=20.
       RMMAX=50.
       THCMIN=0.34906585 
       GEMIN=1. 
       PCMIN=0.4 
       THNMIN=0.17453293 
       ENMIN=1.    
       PRJMAX=1.0 
       PTJMAX=100.
       SWGHTMAX=10.          
        
* *** Define keys
*

       CALL FFKEY('MODE',MODEG, 1,'INTEGER')
       CALL FFKEY('TRIG',NEVNT, 1,'INTEGER')
       CALL FFKEY('DEBU',IDEVT, 3,'INTEGER')
       CALL FFKEY('COND',ICOND, 1,'INTEGER')
       CALL FFKEY('RNDM',NSEED, 1,'INTEGER')
       CALL FFKEY('PROC',NPRC, 1,'INTEGER')
       CALL FFKEY('NFLA',NFLAV, 1,'INTEGER')
       CALL FFKEY('NREM',NREM, 1,'INTEGER')
       CALL FFKEY('POIN',LPOINT, 1,'INTEGER')
       CALL FFKEY('PAWF',PAWF, 80,'MIXED')

       CALL FFKEY('BEAM',BMENER, 1,'REAL')
       CALL FFKEY('Q2XM',RQ2MIN,1,'REAL')
       CALL FFKEY('Q2MI',RM2MIN,1,'REAL')
       CALL FFKEY('Q2CU',RQ2CUT,1,'REAL')
       CALL FFKEY('LAMB',RLAMB,1,'REAL')
       CALL FFKEY('MINV',RZINV,1,'REAL')
c
       CALL FFKEY('PTMA',PTMAX,1,'REAL')
       CALL FFKEY('PZMA',PZMAX,1,'REAL')
       CALL FFKEY('RMMA',RMMAX,1,'REAL')
       CALL FFKEY('TCMI',THCMIN,1,'REAL')
       CALL FFKEY('GEMI',GEMIN,1,'REAL')
       CALL FFKEY('PCMI',PCMIN,1,'REAL')
       CALL FFKEY('TNMI',THNMIN,1,'REAL')
       CALL FFKEY('ENMI',ENMIN,1,'REAL')
       CALL FFKEY('PRMA',PRJMAX,1,'REAL')
       CALL FFKEY('PJMA',PTJMAX,1,'REAL')
       CALL FFKEY('WMAX',SWGHTMAX,1,'REAL')

* *** Define default values of parameters
*
       modegd =modeg
       IDEVTD(1)=IDEVT(1)
       IDEVTD(2)=IDEVT(2)
       IDEVTD(3)=IDEVT(3)
       NEVNTD=NEVNT
       icondd=icond
       NPRCD=NPRC
       NFLAVD=NFLAV
       NREMD=NREM
       LPOINTD=LPOINT

       BMENERD=BMENER
       RQ2MIND= RQ2MIN
       RM2MIND=RM2MIN
       RQ2CUTD=RQ2CUT
       RLAMBD=RLAMB
       RZINVD=RZINV
C
       PTMAXD=PTMAX
       PZMAXD=PZMAX
       RMMAXD=RMMAX
       THCMIND=THCMIN
       GEMIND=GEMIN
       PCMIND=PCMIN
       THNMIND=THNMIN
       ENMIND=ENMIN
       PRJMAXD=PRJMAX
       PTJMAXD=PTJMAX
       SWGHTMAXD=SWGHTMAX
*
       ELSEIF (IC.EQ.-1) THEN
*
*
       CALL FFGO
* *** Compare new values of parameters with default values
*
       PRINT *, '            CHECK FOR NEW VALUES'
       print *,'   '
       CALL SAGIIT(1,MODEGD,MODEG,'MODE')
       CALL SAGIIT(1,NEVNTD,NEVNT,'TRIG')
       CALL SAGIIT(3,IDEVTD,IDEVT,'DEBU')
       CALL SAGIIT(1,ICONDD,ICOND,'COND')
       CALL SAGIIT(1,NPRCD,NPRC,'PROC')
       CALL SAGIIT(1,NFLAVD,NFLAV,'NFLA')
       CALL SAGIIT(1,NREMD,NREM,'NREM')
       CALL SAGIIT(1,LPOINTD,LPOINT,'POIN')

       CALL SAGIFP(1,BMENERD,BMENER,'BEAM')
       CALL SAGIFP(1,RQ2MIND,RQ2MIN,'Q2XM')
       CALL SAGIFP(1,RM2MIND,RM2MIN,'Q2MI')
       CALL SAGIFP(1,RQ2CUTD,RQ2CUT,'Q2CU')
       CALL SAGIFP(1,RLAMBD,RLAMB,'LAMB')
       CALL SAGIFP(1,RZINVD,RZINV,'MINV')
C
       CALL SAGIFP(1,PTMAXD,PTMAX,'PTMA')
       CALL SAGIFP(1,PZMAXD,PZMAX,'PZMA')
       CALL SAGIFP(1,RMMAXD,RMMAX,'RMMA')
       CALL SAGIFP(1,THCMIND,THCMIN,'TCMI')
       CALL SAGIFP(1,GEMIND,GEMIN,'GEMI')
       CALL SAGIFP(1,PCMIND,PCMIN,'PCMI')
       CALL SAGIFP(1,THNMIND,THNMIN,'TNMI')
       CALL SAGIFP(1,ENMIND,ENMIN,'ENMI')
       CALL SAGIFP(1,PRJMAXD,PRJMAX,'PRMA')
       CALL SAGIFP(1,PTJMAXD,PTJMAX,'PJMA')
       CALL SAGIFP(1,SWGHTMAXD,SWGHTMAX,'WMAX')
       WGHTMAX=DBLE(SWGHTMAX)
       ZINV=dble(RZINV)
       DO IL=1,80
        IF(PAWF(IL).EQ.CHBK.OR.PAWF(IL).EQ.CHNL) GOTO 2 
       ENDDO
2      CONTINUE  
       IL=IL-1
c       pawf(il)=chnl           
c EGPS2 initialization

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c        users have to control following four parameters
c        for any process.
c        center mass energy
      ROOTS = DBLE(BMENER*2.)

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c        in this case users should fix the minimum value of
c        virtual mass squared of the virtual photon.
      Q2XMIN = DBLE(RQ2MIN)

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c   Modeg=1 :    choice of process
c      0 : calculate parton distributions in photon.
c      1 : process of real photon and electron scattering
c      2 : process of virtual photon and real photon
c          of electron positron scattering
c   Modeg=2 :     process to be generated
c        nprc = 0 : gamma-gamma scattering with fixed p_T^2
c        nprc = 1 : gamma-gamma scattering
c        nprc = 2 : two quasi-real photon process in e+e- scattering
c

      Q2MAX = ROOTS**2/4.0D0
c          cut off mass squared for partons
c      Q02 = 0.1D0
       Q02 = DBLE(RQ2CUT)
c          virtual mass squared at start of the evolution
C      Q2MIN = 0.25D0
       Q2MIN = DBLE(RM2MIN)
c          QCD scale parameter
      FLAMD = DBLE(RLAMB)
      CALL LAMB

c initial mass
cx      QMASS(1) = 0.5D0
cx      QMASS(2) = 0.5D0
cx      QMASS(3) = 0.5D0
cx      QMASS(4) = 1.6D0
cx      QMASS(5) = 5.0D0
cx      QMASS(6) = 170.0D0
c mass (herwig)
cx      QMASS(1) = 0.32D0
cx      QMASS(2) = 0.32D0
cx      QMASS(3) = 0.5D0
cx      QMASS(4) = 1.8D0
cx      QMASS(5) = 5.2D0
cx      QMASS(6) = 170.0D0
c mass (jetset)
      QMASS(1) = DBLE(ULMASS(2))
      QMASS(2) = DBLE(ULMASS(1))
      QMASS(3) = DBLE(ULMASS(3))
      QMASS(4) = DBLE(ULMASS(4))
      QMASS(5) = DBLE(ULMASS(5))
      QMASS(6) = DBLE(ULMASS(6))
C
       write(6,9001)(qmass(i),i=1,6)
 9001  format(' qmass =',6G15.5)
c      color
      CF =4.0D0/3.0D0
      CA = 3.0D0
      TR = 0.5D0
      PI = 4.0D0*ATAN(1.0D0)
      BETA0 = (CA*11.0D0 -4.0D0*TR*NFLAV)/3.0D0


      KZAP = 0
      ecm = roots
      s = ecm*ecm
      xbmin = 1.0d-5
      zmin = 1.0d-5
      ame2 =(0.511d-3)**2
      ecm = roots
      q2max = s/4.0d0
      q2xmax = q2max

      if( nprc .eq. 1)then
c
c              real prcess of electron and photon
c           ecm : total energy of c.m. system of electron and photon
c
          xbmin = q2max / s

      else if( nprc .eq. 2)then
c
c            virtual and real photon  process of electron and positron
c            scattering
c
           ecmx0 = roots
           if (modeg.eq.1 ) zmin = q2xmin/s
           if (modeg.eq.2 ) zmin = 4.0d0*q2xmin/s
           if (modeg.eq.2 ) then 
                            LPOINT =0
           end if
c
       else
c
c           generate parton distributions of photon
c
           xbmin = 0.0d0
           q2max = q2xmin
           q2xmax = q2max

       endif

 

      WRITE(6,10)
      if ( modeg.eq.0 ) then
        write(6,19) 
        stop
      else if (modeg.eq.1) then
        write(6,11)
      else if (modeg.eq.2) then
        write(6,12)
      else
        write(6,19) 
        stop
      end if
      WRITE(6,20)NPRC
      WRITE(6,30)ECM
      WRITE(6,40)-Q2MAX
      write(6,45)-q2xmin
      WRITE(6,50)FLAMD
      WRITE(6,52)NFLAV
      IF(NREM.EQ.0) THEN
       WRITE(6,63)
      ELSEIF(NREM.EQ.1) THEN
       WRITE(6,64)
      ENDIF       
      WRITE(6,70)Q02
      WRITE(6,72)Q2MIN
      WRITE(6,80)NEVNT
      WRITE(6,90)KZAP
 
      IF( NPRC .EQ.2)THEN
       WRITE(6,100)Q2XMIN
       WRITE(6,102)Q2XMAX
       write(6,110)zmin
       IF(LPOINT.EQ.0)WRITE(6,*)'NO PHOTON IS POINT-LIKE '
       IF(LPOINT.EQ.1)WRITE(6,*)'RESTRICT ONE PHOTON IS POINT-LIKE '
       IF(LPOINT.EQ.2)WRITE(6,*)'RESTRICT TWO PHOTONS ARE POINT-LIKE '
      endif

      END IF
      return
1000  continue
      return
5000  continue
      IF(IL.GT.0)CALL USPAW(PAWF(1),IL)
      return

   10 FORMAT( ' Parton shower in photon-photon scattering' )
   11 format( ' MODE=1 : Deep-inelastic scattering of electron-photon')
   12 format( ' MODE=2 : Quasi-real photon-photon scattering')
   19 format( ' MODE is undefined, or wrong. Execution terminates.')

   20 FORMAT(' real pro(ee):2, real pro.(e-gamma).:1',
     +'parton distri.:0 ',I3)
   30 FORMAT(' Total energy                                = ',G15.5)
   40 format(' maximum virtual mass squared of the photon  = ',G15.5)
   45 format(' minimum virtual mass squared of the photon  =',G15.5)
   50 format(' QCD param.  Lambda                          = ',G15.5)
   52 format(' No. of flavor                               = ',I5)
   63 format(' Remnant of the photon emiting a gluon is a gluon') 
   64 format(' Remnant of the photon emiting a gluon is a q-qb pair')  
   70 format(' Cutoff mass squared                         = ',G15.5)
   72 format(' Initial Q**2                                = ',G15.5)
   80 format(' Number of Event                             = ',I8)
   90 format(' Argument of alpha-s is K^2(0) or Pt^2       = ',I5)
  100 format(' Minimum of Q**2 of virtual photon           = ',G15.5)
  102 format(' Maximum of Q**2 of virtual photon           = ',G15.5)
  110 format(' mini. ener. frac. of real photon in positron= ',G15.5)

      END
