
c----------------------------------------------------------------------
c qcprep : ggps
c
c  prologue procedure for parton shower
c
c  Updated on 95/11/24
c----------------------------------------------------------------------
c
      subroutine qcprep
c
      implicit real*8(a-h,o-z)
c
      common/modegg/modeg,neven
      common/color/cf,ca,tr,pi,beta0
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/qcflg/kzap,nao
      common/tpnes/pnes(0:100,0:10),tmaxs,tmins,ndims
      common/tpnet/pnet(0:100,0:10),tmaxt,tmint,ndimt
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm
      common/qcwght/wght0,fail,wght,accptx
      common/cross/sigma0,sigmax,sigma
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/rslx/fph0,fph0x
      common/prcss/ecm,xbmin,nprc
      common/point/lpoint

      write(6,601)

c size of array for Sudakov factors
      ndim = 100
      ndims = ndim
      ndimt = ndim
c
      flamd2 = flamd**2
c
      fac = 2.0d0/beta0
      ymax = log(q2max/flamd2)
      ymin = log(q2min/flamd2)
      ycut = log(q02/flamd2)
      yycut =  log(ycut)
      dy = ( ymax - ymin )/ndim
c
      tmaxs = ymax
      tmins = ymin
      tmaxt = ymax
      tmint = ymin

c
      do 101 k=0,ndim
              y = ymin + k*dy
c
              if( kzap .eq. 0)then
              fys1= y - (ycut+11.0d0/12.0d0)*log(y)
              fyt1= y - (ycut+11.0d0/12.0d0)*log(y)
                              else
              fys1= y*(log(y)-1.0d0) - (yycut+11.0d0/12.0d0)*log(y)
              fyt1= y*(log(y)-1.0d0) - (yycut+11.0d0/12.0d0)*log(y)
                              endif
              fys2 = 1.0d0/3.0d0*log(y)
              fyt2 =2.0d0/3.0d0*log(y)
              pnes(k,0) = fac*(ca*2.0d0*fys1+nflav*2.0d0*tr*fys2)
              pnet(k,0) = fac*(ca*2.0d0*fyt1+nflav*2.0d0*tr*fyt2)
 101  continue
      pnsx = pnes(ndim,0)
      pntx = pnet(ndim,0)

c
      do 102 k=0,ndim
              pnes(k,0)=pnes(k,0) - pnsx
              pnet(k,0)=pnet(k,0) - pntx
 102  continue

c
      do 110 nf=1,nflav
          do 111 k=0,ndim

              y = ymin + k*dy
c
              if(kzap .eq. 0)then
                  fys1= 2.0d0*y - (2.0d0*ycut+17.0d0/6.0d0)*log(y)
                  fyt1= 2.0d0*y - (2.0d0*ycut+4.0d0/3.0d0)*log(y)
              else
                  fys1= 2.0d0*y*(log(y)-1.0d0)-
     1               (2.0d0*yycut+17.0d0/6.0d0)*log(y)
                  fyt1= 2.0d0*y*(log(y)-1.0d0)-
     1               (2.0d0*yycut+4.0d0/3.0d0)*log(y)
              endif
              fys2 = 4.0d0/3.0d0*log(y)
              pnes(k,nf) = fac*cf*(fys1+fys2)
              pnet(k,nf) = fac*cf*(fyt1)
 111      continue
          pnsx = pnes(ndim,nf)
          pntx = pnet(ndim,nf)

c
          do 112 k=0,ndim
              pnes(k,nf)=pnes(k,nf) - pnsx
              pnet(k,nf)=pnet(k,nf) - pntx
 112      continue
 110  continue
c
      ntbl =0
      if(ntbl.eq.1)then
        write(6,650)
        do 115 i=0,ndim
          write(6,651) i,pnes(i,0),pnes(i,1),pnet(i,0),pnet(i,1) 
 115    continue
      endif
      ntbl = 1
c
c     parameters of resolved photon and quark pair created photon
c 
      alpha = 1.0d0/137.0d0
      nfl = 4
      nfvm = 2

c     eeav : charge average
c         1/3   :integration of x(x**2+(1-x)**2)
c      3  : color factor
c      2  : kinematical one
c
cx          eeav=(4.0/9.0+1.0/9.0+1.0/9.0)
      eeav=(4.0d0+2.0d0)/9.0d0
cx        spph = alpha/2.0/pi*(1.0/3.0)*2.0*3.0*eeav
      spph = alpha/pi*eeav
cx        spphc = alpha/2.0/pi*(1.0/3.0)*2.0*3.0*(4.0/9.0)
      spphc = alpha/pi*(4.0d0/9.0d0)
c
c     paramaters of hadronic components
c     ( Gluck .., P.R.D46(1992)1973   )
      vmuaa =0.235d0
      vmua = 0.5d0
      vmub = 0.082d0
      vmuc = 0.354d0
      vxmu = 0.5d0
      vmunr =  0.131d0 * nfvm*2
c
      vmgaa =0.535d0
      vmga = 0.462d0
      vmgb = 0.354d0
      vmgc = 0.233d0
      vxmg =  1.0d0
      vmgnr =  0.390
c
      alam2 = flamd**2
      qq0 = q2min
      qq  = q2max
      if(qq.le.qmass(4)**2)write(6,*)' qq < charm mass**2 '
      fph0x = spph*log(qq/qq0)
      fph0 = spph*log(qq/qq0)+ spphc*log(qq/qmass(4)**2)
      if(ntbl.eq.1)then
          write(6,610)fph0x,fph0
      endif
c
c
      alpi = alpha/2.0d0/pi
c     hadronic component
      fvm = alpha* ( vmunr + vmgnr)

      if(modeg.eq.1)then 

          fint = fph0 + fvm
          walph = alpha
          rtph = fph0/walph
          rtvm = fvm/walph
          rtx =  rtph + rtvm
          wght0 = rtx
          rtph =rtph/rtx
          rtvm =rtvm/rtx

      endif

c
      if(modeg .eq. 2)then

         fpo0 = 1.0d0
         fpo = fpo0*alpha
         if(ntbl.eq.1)then
         write(6,620)fpo,fpo0
         endif

c
          fint = fph0 + fvm+fpo
c
          walph = alpha
          rtph = fph0/walph
          rtvm = fvm/walph
          rtpo = fpo/walph
          rtx =  rtph + rtvm + rtpo
          wght0 = rtx
          if(ntbl.eq.1)then
             write(6,630)rtx,rtph,rtvm,rtpo
          endif

          rtph =rtph/rtx
          rtpo =rtpo/rtx
          rtvm =rtvm/rtx

      endif

      if(ntbl.eq.1)then
         write(6,640)rtx,rtph,rtvm,rtpo
      endif

c
c       tentative total cross section
c       reference cross section (QED muon pair)
c       sigma0=4pi*alpha**2/s/3 = 86.856/s(GeV^2) (nb)
c      4pi*alpha**2 int dQ^2/Q^4 Fgamma/e(z,E) int dx xf(x)

      if(modeg.eq.1)then 

          if( nprc .eq. 2)then
              esum = alpha*rtx*4.0d0/9.0d0 
ctttttttttttttttttt    1996.10.30
        sigma0 = 86.856d3/(4.0d0*pi*alpha**2/3.0d0)
ctttttttttttttttttt    1996.10.30
              eng = ecmx0/2.0d0
              ame = sqrt(ame2)
              rm = 1.0d0/q2xmin - 1.0d0/q2xmax
              fsum=ft(zmin,eng,ame)*alpha/pi
cx              sigmax = sigma0*rm*fsum*esum
ctttttttttttttttttt    1996.10.30
cxxxxx        sigmax = sigma0*rm*fsum*esum
        sigmax = sigma0*4.0d0*pi*alpha**2*rm*fsum*esum
ctttttttttttttttttt    1996.10.30
c
ccccc       factor 2 : e+ large angle scattering  as well as e-
              sigmax = sigmax*2.0d0 

              write(6,602) sigma0,rm,fsum,esum,sigmax
          endif

      endif

c
c       tentative total cross section
c       reference cross section (QED muon pair)
c       sigma0=4pi*alpha**2/3s = 86.856/s(GeV^2) (nb)

      if(modeg .eq. 2)then

        if( nprc .eq. 1)then

          if(lpoint .eq. 0)then
            esum = rtx**2*alpha**2
          elseif(lpoint .eq. 1)then
            esum = rtx*alpha**2
          else
            esum = alpha**2
          endif

          sigma0 = 86.856d3/(alpha**2*4.0d0*pi/3.0d0)
          rm = pi*(-log(q2xmin)+log(q2xmax))/roots**2
          sigmax = sigma0*rm*esum

          write(6,603) sigma0,rm,esum,sigmax

          qq =q2xmin

          if(qq.le.qmass(4)**2)write(6,*)' qq < charm mass**2 '
          fph0x = spph*log(qq/qq0)
          fph0 = spph*log(qq/qq0)+ spphc*log(qq/qmass(4)**2)
c
          walph = alpha
          rtphmn = fph0/walph
          rtxmn =  rtphmn + (rtvm + rtpo)*rtx

          write(6,604) fph0,walph,rtxmn
            
        endif

c
        if( nprc .eq. 2)then
          sigma0 = 86.856d3/(alpha**2*4.0d0*pi/3.0d0)
          eng = ecmx0/2.0d0
          ame = sqrt(ame2)
          esum = rtx**2*alpha**2
          rm = pi*(1.0d0/q2xmin - 1.0d0/q2xmax)
  
          write(6,605) zmin,eng,ame
  
          fsum=ft(zmin,eng,ame)*alpha/pi
          fsum0=2.0d0*log(1.0d0/zmin)*(log(eng/ame)-0.5d0)*alpha/pi

          write(6,606)fsum,fsum0,fsum**2,fsum0**2

          sigmax = sigma0*rm*fsum**2*esum

          write(6,603) sigma0,rm,esum,sigmax
          write(6,608) sigma0*rm*esum

          qq =q2xmin
          if(qq.le.qmass(4)**2)write(6,*)' qq < charm mass**2 '
          fph0x = spph*log(qq/qq0)
          fph0 = spph*log(qq/qq0)+ spphc*log(qq/qmass(4)**2)
c
          walph = alpha
          rtphmn = fph0/walph
          rtxmn =  rtphmn + (rtvm + rtpo)*rtx
          write(6,604) fph0,walph,rtxmn
          write(6,609) rtpo,rtx

        endif

      endif

      write(6,699)

      return
  601 format(/' ----- Information from qcprep')
  699 format(' ----- End of Information from qcprep'/)
  650 format(' #  ' ,5x,'pnes(i,0)',5x,'pnes(i,1)',5x,'pnet(i,0)',5x,
     1 'pnet(i,1) ')
  651 format(' ',i3,' ',4(G12.4,2X))
  610 format(' probability of resolving(uds),(udsc)=',G15.5,3X,G15.5)
  620 format(' point-like int. prob.(/alpha)=',G15.5,3X,G15.5)
  630 format(' prob. of total,resol.,VM,point ='/1h ,4x,4(G15.5,2X))
  640 format(' total prob. ',G15.5/' frac. of resol.,VM,point =',
     &    3(G15.5,2X))
  602 format(' sigma0=',g20.5/' rm=',g20.5/' fsum=',g20.5/
     & ' esum=',g20.5/' sigmax=',g20.5)
  603 format(' sigma0=',g20.5/' rm=',g20.5/
     & ' esum=',g20.5/' sigmax=',g20.5)
  604 format(' fph0=',g20.5/' walph=',g20.5/' rtxmn=',g20.5)
  605 format(' zmin=',g20.5/' eng=',g20.5/' ame=',g20.5)
  606 format(' fsum=',g20.5/' fsum0=',g20.5/
     & ' fsum**2=',g20.5/' fsum0**2=',g20.5)
  608 format(' sigma(rm,esum) =',g20.5)
  609 format(' rtpo=',g20.5/' rtx=',g20.5)
      end

c----------------------------------------------------------------------
c  ft : ggps
c
c  Updated on 95/11/24
c----------------------------------------------------------------------
      real*8 function ft(z,eng,ame)
      IMPLICIT REAL*8(A-H,O-Z)
c
      zl=log(z)
      z1 = 1.0d0 - z
c
c
      f= 2.0d0*(-zl-z1+0.25d0*(1.0d0-z*z))*(log(eng/ame)-0.5d0)
c
      ft = f
cx         write(6,*)' z, f1,f2,ft=',z,f1,f2,ft
      return
      end

c----------------------------------------------------------------------
c  ggpsgo : ggps
c
c  Execute main body of the physical process
c
c  Updated on 95/11/24
c----------------------------------------------------------------------

      subroutine ggpsgo(nfail)

c * argument
c   nfail : out : Status flag. For failed event nfail=1.

c      Steps for generation of
c      virtual photon and real photon events in e+ e- process
 
c      step 1: pick up Q^2
c      step 2: pick up energy of real photon
c      step 3: make shower of electron and photon system
c      step 4: make boost of Lab. system

c    Watch parameter, keep 0 for normal case.
      parameter (nwatch=0)

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,accptx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm
      common/cross/sigma0,sigmax,sigma
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/modegg/modeg,neven
c
      nfail = 0

      if( nwatch.eq.1 ) write(6,*) 'Enter ggpsgo .....'

      if((modeg.eq.1.and.nprc.eq.2)
     &        .or.( modeg.eq.2.and. nprc. ge. 1))then

c generate a real photon 
           nfailx = 0
           if(modeg.eq.1) call ggq1(q2,ecmx,nfailx)
           if(modeg.eq.2) call ggq2(q2,ecmx,nfailx)

           if( nwatch.eq.1 ) write(6,*) 'After ggq1/2 ... nfailx=',nfailx
           if( nwatch.eq.1 ) write(6,*) ' q2,ecmx=',q2,' , ',ecmx
           if( nfailx .eq. 1) then
              nfail = 1
              return
           endif
           q2max = q2

           if( nprc.eq.2) ecm = ecmx
c
      endif

c generation of shower event
      nfailx = 0
      call qcgen(nfailx)

      if( nwatch.eq.1 ) write(6,*) 'After qcgen1/2 ... nfailx=',nfailx
      if( nfailx .eq. 1) then
              nfail = 1
              return
      endif

c subroutine to go to CM system
      if(nprc .eq.2)then
             call labsys
            if( nwatch.eq.1 ) write(6,*) 'After labsys1/2 ... '
      endif

      return
      end

c----------------------------------------------------------------------
c ggq1: ggps
c
c
c  Updated on 95/11/24
c----------------------------------------------------------------------
c
      subroutine ggq1(q2,ecmx,nfailx)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,accptx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      
               nfailx = 0
c
c       pick up Q^2
c
           rm = 1.0d0/q2xmin - 1.0d0/q2xmax
c
       rq = rm*random(1) + 1.0d0/q2xmax
             q2 = 1.0d0/rq
c
           zmax = 1.0d0
          zlmin = log(zmin)
          zlmax = log(zmax)
          ame = sqrt(ame2)
          
          fxm=2.0d0*(log(ecmx0/ame)-0.5d0)
           do 201 i=1,100
          zl = (zlmax-zlmin)* random(1)+zlmin
          z = exp(zl)
          fx = (1.0d0+(1.0d0-z)**2)
          fx = fx * (log(ecmx0/ame)-0.5d0)
c
           if( fx .ge. fxm*random(1))goto 211
 201      continue
        write(6,*) 'ggq1 : failed in loop 100 times'
 211      continue
c
          ecmx2 = z* ecmx0**2
          ecmx = sqrt(ecmx2)
c
         xbmin = q2/ecmx**2
c
         if( xbmin .ge. 1.0d0)then
              nfailx = 1
                              endif
          return
          end

c----------------------------------------------------------------------
c ggq2 : ggps
c
c
c  Updated on 95/11/24
c----------------------------------------------------------------------
      subroutine ggq2(q2,ecmx,nfailx)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,accptx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm
      common/cross/sigma0,sigmax,sigma
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/prcxx/wtype(20),type(20),btype(10)
      common/phspc/z1,z2
      common/point/lpoint
      
               nfailx = 0
c
         if( nprc .eq. 1)then
           rm = -log(q2xmin)+log(q2xmax)
       rq = rm*random(1)+log(q2xmin)
             q2 = exp(rq)
          ecmx = ecmx0
c
      rtxx=rtxmn + (rtx-rtxmn)*log(q2/q2xmin)/log(q2xmax/q2xmin)

        if( lpoint .eq. 0)then
        if(random(1).ge.(rtxx/rtx)**2)then
               nfailx = 1
              return
                                      else
              return
                                      endif
        elseif( lpoint .eq. 1)then
        if(random(1).ge.(rtxx/rtx))then
               nfailx = 1
              return
                                   else
              return
                                   endif
        else
              return
                                   endif
                   endif
        if(nprc .ne. 2)then
           write(6,*)' error in ggq2'
                     stop
                       endif
c
c       pick up Q^2
c
           rm = 1.0d0/q2xmin - 1.0d0/q2xmax
c
       rq = rm*random(1) + 1.0d0/q2xmax
             q2 = 1.0d0/rq
c
c
      rtxx=rtxmn + (rtx-rtxmn)*log(q2/q2xmin)/log(q2xmax/q2xmin)

        if(random(1).ge.(rtxx/rtx)**2)then
               nfailx = 1
              return
                                      endif
           zmax = 1.0d0
          zlmin = log(zmin)
          zlmax = log(zmax)
          ame = sqrt(ame2)
          
          fxm=2.0d0*(log(ecmx0/ame)-0.5d0)
           do 200 iz =1,2
           do 201 i=1,100
          zl = (zlmax-zlmin)* random(1)+zlmin
          z = exp(zl)
          fx = (1.0d0+(1.0d0-z)**2)
          fx = fx * (log(ecmx0/ame)-0.5d0)
c
           if( fx .ge. fxm*random(1))goto 211
 201      continue
        write(6,*) 'ggq2 : failed in loop 100 times'
 211      continue
          if(iz.eq.1)z1=z
          if(iz.eq.2)z2=z
 200      continue

          ecmx2 = z1*z2* ecmx0**2
          ecmx = sqrt(ecmx2)
c
         xbmin = q2/ecmx**2
c
         if( xbmin .ge. 1.0d0)then
              nfailx = 1
                              endif
          return
          end

c----------------------------------------------------------------------
c qcgen: ggps
c
c
c  Updated on 96/02/03
c----------------------------------------------------------------------
      subroutine qcgen(nfailx)
c The following parameter is normally 0.
      parameter( monit=0 )
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,fail2
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/modegg/modeg,neven
c
      nfailx = 0 
c
      do 1 i=1,100
      do 1 j=1,10
             partn(j,i)=0.0d0
             listp(j,i)=0
    1 continue
c
      ntop = 0

      if (monit.eq.1) write(6,*) 'Enter qcgen, end reset /qcevnt/'
c
      if(modeg.eq.1) call rslv1(nfail)
      if(modeg.eq.2) call rslv2(nfail)
c
      if( nfail .eq. 1 ) then
          nfailx = 1
          if(monit.eq.1) write(6,*) 'Failed rslv/qcgen, fail=',fail
          return
      endif
c
      call psint
c
      if( nprc .lt. 1 .and. modeg.eq.1 ) return
c
      if(modeg.eq.1)   call scatt1(nfail)
      if(modeg.eq.2)   call scatt2(nfail)
c
      if( nfail .eq. 1 ) then
          nfailx = 1
          if(monit.eq.1) write(6,*) 'Failed scatt/qcgen, fail=',fail
          return
      endif
c
      call psfnl
c
      if(modeg.eq.1)       call cms1(nfail)
      if(modeg.eq.2)       call cms2(nfail)
c
      if( nfail .eq. 1 ) then
          nfailx = 1
          if(monit.eq.1) write(6,*) 'Failed cms/qcgen, fail=',fail
          return
      endif
c
      return
      end

c----------------------------------------------------------------------
c labsys : ggps
c
c
c  Updated on 96/02/03
c----------------------------------------------------------------------
      subroutine labsys
c Normally nosym=0
      parameter (nosym = 0)

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,accptx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm

      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/color/cf,ca,tr,pi,beta0
      common/phspc/z1,z2
      common/modegg/modeg,neven

      dimension pppp(4,100),pref(4)
c
      if (modeg.eq.1 ) then

c /mode-1/
         z= ecm**2/ecmx0**2

         L1 = ntop + 1
         partn(2,L1) =  0.0d0
         partn(3,L1) =  0.0d0
         partn(4,L1) =  0.0d0
         partn(5,L1) =  0.0d0
         partn(6,L1) =  ecmx0/2.0d0
         partn(7,L1) =  ecmx0/2.0d0

         listp(1,L1) = -11
         listp(2,L1) = 0
         listp(3,L1) = 1
         listp(4,L1) = 1
         listp(5,L1) = 2
         listp(6,L1) = -2

         L2 = ntop + 2
         partn(2,L2) =  0.0d0
         partn(3,L2) =  0.0d0
         partn(4,L2) =  0.0d0
         partn(5,L2) =  0.0d0
         partn(6,L2) = (1.0d0-z)*ecmx0/2.0d0
         partn(7,L2) = (1.0d0-z)*ecmx0/2.0d0

         listp(1,L2) = -11
         listp(2,L2) = 1
         listp(3,L2) = 0
         listp(4,L2) = 0
         listp(5,L2) = 2
         listp(6,L2) = 2

       else

c /mode-2/
         L1 = ntop + 1
         partn(2,L1) =  0.0d0
         partn(3,L1) =  0.0d0
         partn(4,L1) =  0.0d0
         partn(5,L1) =  0.0d0
         partn(6,L1) =  ecmx0/2.0d0
         partn(7,L1) =  ecmx0/2.0d0

         listp(1,L1) = -11
         listp(2,L1) = 0
         listp(3,L1) = 1
         listp(4,L1) = 2
         listp(5,L1) = 2
         listp(6,L1) = -2

         L1 = ntop + 2
         partn(2,L1) =  0.0d0
         partn(3,L1) =  0.0d0
         partn(4,L1) =  0.0d0
         partn(5,L1) =  0.0d0
         partn(6,L1) = -ecmx0/2.0d0
         partn(7,L1) =  ecmx0/2.0d0

         listp(1,L1) = 11
         listp(2,L1) = 0
         listp(3,L1) = 1
         listp(4,L1) = 2
         listp(5,L1) = 2
         listp(6,L1) = -2

c       final electron and positron
         L2 = ntop + 3
         partn(2,L2) =  0.0d0
         partn(3,L2) =  0.0d0
         partn(4,L2) =  0.0d0
         partn(5,L2) =  0.0d0
         partn(6,L2) = (1.0d0-z1)*ecmx0/2.0d0
         partn(7,L2) = (1.0d0-z1)*ecmx0/2.0d0

         listp(1,L2) = -11
         listp(2,L2) = 2
         listp(3,L2) = 0
         listp(4,L2) = 0
         listp(5,L2) = 2
         listp(6,L2) = 2
c
         L2 = ntop + 4
         partn(2,L2) =  0.0d0
         partn(3,L2) =  0.0d0
         partn(4,L2) =  0.0d0
         partn(5,L2) =  0.0d0
         partn(6,L2) =-(1.0d0-z2)*ecmx0/2.0d0
         partn(7,L2) = (1.0d0-z2)*ecmx0/2.0d0

         listp(1,L2) = 11
         listp(2,L2) = 2
         listp(3,L2) = 0
         listp(4,L2) = 0
         listp(5,L2) = 2
         listp(6,L2) = 2

      end if
c
cccc      call qclist


c  boost to center mass system of electron and positron
      pref(1)=0.0d0
      pref(2)=0.0d0
      if( modeg.eq.1 ) then
           pref(3)=-(1.0d0 - z)*ecmx0/2.0d0
           pref(4)= (1.0d0+z)*ecmx0/2.0d0
      else
           pref(3)= (z1-z2)*ecmx0/2.0d0
           pref(4)= (z1+z2)*ecmx0/2.0d0
      end if

      do 201 i=1,ntop
      do 201 k=1,4
           pppp(k,i)=partn(3+k,i)
  201 continue

      nnn1 = 1
      nnn2 = ntop
      CALL BOOST( PPPP , PREF , NNN1 , NNN2 )
c
      do 211 i=1,ntop
      do 211 k=1,4
           partn(3+k,i) = pppp(k,i)
  211 continue
c
      if( modeg.eq.1 ) then
          ntop = ntop + 2
      else
          ntop = ntop + 4
      end if

c
      if( modeg.eq.2 ) return

c
c         symmetric treatment
c
      if( nosym .eq. 0 )then

          xx = random(1)
          if( xx .ge. 0.5d0 ) then
            do 221 i=1,ntop
              partn(6,i) = -partn(6,i)
              id=listp(1,i)
              if(abs(id).eq.11) listp(1,i)=-id
 221        continue
          endif

c         symmetric treatment on the azimuthal angle of lepton
c
          phi = 2.0d0*pi*random(1)
          cs = cos(phi)
          sn = sin(phi)
          do 231 i=1,ntop
              px =partn(4,i) 
              py =partn(5,i) 
              partn(4,i) = px*cs -py*sn
              partn(5,i) = px*sn +py*cs
 231      continue

      endif

      return
      end
