
c----------------------------------------------------------------------
c jinput : ggps
c
c
c  Updated on 96/01/18
c----------------------------------------------------------------------

      subroutine jinput(nfin)

c Read 'nfin' and get input control parameters
c
c arguments:
c
c   nfin : IN  : unit number of input file
c
c note : file open/close procedures are to be done in 
c        calling routine.
c note : parameter line format assumed **IMPORTANT**
c        4-character keyword, space(s), a numerical value 
c        If a line starts from c or C, the line is a comment.
 
      IMPLICIT REAL*8(A-H,O-Z)

c npars = number of parameters
c iprint =0 silent, =1 report 
      parameter(npars=27, iprint=1)

c string for a line
      character*72 cline 
      character*20 cline1

c integer and real parameters
      dimension ipars(npars),rpars(npars),nspars(npars),ispars(npars)
c label for keywords
      character*4 cpars(npars)

c labels
      data cpars/
     1 'LIST','BEAM','TRIG','DEBU','RNDM','COND','MODE','PROC',
     2 'MINV','Q2XM','Q2MI','Q2CU','LAMB','NFLA','KZAP','NREM',
     3 'POIN','WMAX','TCMI','GEMI','TNMI','ENMI','PRMA','PJMA',
     4 'PTMA','PZMA','RMMA'
     x /
      data ispars/
     1  -1   ,  1   ,  0   ,  0   ,  0   ,  0   ,  0   ,  0   ,
     2   1   ,  1   ,  1   ,  1   ,  1   ,  0   ,  0   ,  0   ,
     3   0   ,  1   ,  1   ,  1   ,  1   ,  1   ,  1   ,  1   ,
     4   1   ,  1   ,  1   
     x  /

      do 10 n=1,npars
   10 nspars(n)=0
c
      if (iprint.eq.1) write(6,601)
      nline =0
  100 continue
      read(nfin,501,end=199) cline
      nline = nline+1
      if( iprint.eq.1 ) write(6,602) nline,cline

      if( cline(1:1).ne.'c' .and. cline(1:1).ne.'C' ) then

        ll=len(cline)
        do 15 k=ll,1,-1
          if ( cline(k:k).ne.' ' ) then
            lend = k
            go to 16
          end if
   15   continue
        lend=0
   16   continue

        do 20 n=1,npars
          lpos = index(cline,cpars(n))
          if ( lpos.ne.0 .and. (lpos+4).lt.lend) then
c           write(6,*) lpos,',',lend,',',n,' ',cpars(n)
            nspars(n) = 1
            cline1='                    ' 
            cline1(20-(lend-lpos-4):20)=cline(lpos+4:lend)
            if(ispars(n).eq.0) read(cline1,502) ipars(n)
            if(ispars(n).eq.1) read(cline1,503) rpars(n)
          else
            if( ispars(n).lt.0 ) nspars(n) =1
          end if
   20   continue
      end if
      
      go to 100
c
  199 continue

      if( iprint.eq.1 ) then
      write(6,605)
      do 30 n=1,npars
        if( nspars(n).eq.0 ) then
          write(6,610) n,cpars(n)
        else
          if( ispars(n).eq.-1) write(6,613) n,cpars(n)
          if( ispars(n).eq.0 ) write(6,611) n,cpars(n),ipars(n)
          if( ispars(n).eq.1 ) write(6,612) n,cpars(n),rpars(n)
        end if
   30 continue
      end if

c
c  put parameters into common areas
      nn = npars
      call qcinpt( nn, nspars, ipars, rpars )

      return
c
  501 format(a72)
  502 format(i20)
  503 format(f20.0)
  601 format(/' ----- Echo of input lines')
  602 format(1h ,i3,' ) ',a72)
  605 format(/' ----- Input parameters')
  610 format(1h ,i3,' ' ,a4,' ... NO INPUT')
  613 format(1h ,i3,' ' ,a4,' ... SET')
  611 format(1h ,i3,' ' ,a4,' ', i10)
  612 format(1h ,i3,' ' ,a4,' ',g20.8)
      end

c----------------------------------------------------------------------
c qcinpt : ggps
c
c
c  Updated on 96/01/18
c----------------------------------------------------------------------
c
      subroutine qcinpt( npar, nspars, ipars, rpars )
c
      IMPLICIT REAL*8(A-H,O-Z)
      dimension nspars(1),ipars(1),rpars(1)

      common/color/cf,ca,tr,pi,beta0
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/prcss/ecm,xbmin,nprc
      common/qcflg/kzap,nao
      COMMON /QCRND/ NSEED
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/point/lpoint
      common/remnat/nrem
      common/modegg/modeg,neven

c mode frag to specify 1=DIS, 2=two quasi-real photons
      modeg =ipars(7)

c event number of generation.
      if( nspars(3).eq.0 ) ipars(3)=100
      neven =ipars(3) 

c center mass energy
      if( nspars(2).eq.0 .and. modeg.eq.1 ) rpars(2)=95.0
      if( nspars(2).eq.0 .and. modeg.eq.2 ) rpars(2)=90.0
      roots =rpars(2)*2.0d0

c
c    minimum value of virtual mass squared of the virtual photon.
c           for deep inelasctic scatt.
c    minimum value for the transverse momentum squared of jets
c           for two quasi-real photon scatt.
      if( nspars(10).eq.0 .and. modeg.eq.1 ) rpars(10)=10.0
      if( nspars(10).eq.0 .and. modeg.eq.2 ) rpars(10)=20.0
      q2xmin = rpars(10)

c nprc
      if( nspars(8).eq.0 ) ipars(8)=2
c
c   choice of process for DIS
c      0 : calculate parton distributions in photon.
c      1 : process of real photon and electron scattering
c      2 : process of virtual photon and real photon
c          of electron positron scattering
c
      if(modeg.eq.1)then
        nprc = ipars(8)
      endif

c
c   choice of process for two quasi-real photons
c        nprc = 0 : gamma-gamma scattering with fixed p_T^2
c        nprc = 1 : gamma-gamma scattering
c        nprc = 2 : two quasi-real photon process in e+e- scattering
c
      if(modeg.eq.2)then
        nprc = ipars(8)
      endif

      if(modeg.eq.1) q2max = roots**2
      if(modeg.eq.2) q2max = roots**2/4.0d0

c virtual mass squared at start of the evolution
      if( nspars(11).eq.0 ) rpars(11)=0.25d0
      q2min =  rpars(11)

c  cut off mass squared for partons
      if( nspars(12).eq.0 ) rpars(12)=0.1d0
      q02   = rpars(12)
c
c QCD scale parameter
      if( nspars(13).eq.0 ) rpars(13)=0.23d0
      flamd = rpars(13)

c quark masses
              qmass(1) = sqrt(q2min)
              qmass(2) = sqrt(q2min)
              qmass(3) = sqrt(q2min)
              qmass(4) = 1.6d0
       qmass(1) =  5.599999800324440E-03
        qmass(2) =  9.899999946355819E-03
        qmass(3) =  .1990000009536743
        qmass(4) =  1.35000002384186
              qmass(5) = 5.0d0
              qmass(6) = 170.0d0

c number of flavors
      if( nspars(14).eq.0 ) ipars(14)= 4
      nflav = ipars(14)

c      color factor
             cf =4.0d0/3.0d0
             ca = 3.0d0
             tr = 0.5d0
             pi = 4.0d0*atan(1.0d0)
             beta0 = (ca*11.0d0 -4.0d0*tr*nflav)/3.0d0

c  function random(1): generator of random number
      if( nspars(5).eq.0 ) ipars(5)= 9876543
      nseed  = ipars(5)

c  choice of argument of alpha-s
      if( nspars(15).eq.0 ) ipars(15)= 0
      kzap = ipars(15)

c
      if(modeg.eq.1)then
               ecm = roots
               s = ecm*ecm
               xbmin = 1.0d-5
               zmin = 1.0d-5
               ame2 =(0.511d-3)**2

          if( nprc .eq. 1)then
c
c              real prcess of electron and photon
c           ecm : total energy of c.m. system of electron and photon
c
               ecm = roots
               s = ecm*ecm
               q2max  = s/4.0d0
               q2xmax = q2max
               xbmin = q2max / s

          else if( nprc .eq. 2) then
c
c            virtual and real photon  process of electron and positron
c            scattering
c
               ecmx0 = roots
               ecm = ecmx0
               s = roots*roots
               q2max  = s/4.0d0
               q2xmax = q2max
               zmin = q2xmin/s
               ame2 =(0.511d-3)**2
c
          else
c
c           generate parton distributions of photon
c
               xbmin = 0.0d0
               q2max = q2xmin
               q2xmax = q2max

          endif

      endif

c
      if(modeg.eq.2)then

          if( nprc .eq. 1) then
c
c            virtual and real photon  process of electron and positron
c            scattering
c
               ecm = roots
               s = ecm*ecm
               xbmin = q2xmin/(s/4.0d0)
               s = roots*roots
               q2xmax = q2max
c
               lpoint =0
c

          else if( nprc .eq. 2) then
c
c            real and real photon  process of electron and positron
c            scattering
c
                ecmx0 = roots
                ecm = ecmx0
                s = roots*roots
                q2xmax = q2max
                zmin = 4.0d0*q2xmin/s
                ame2 =(0.511d-3)**2
c
                lpoint =0
c
          else

          endif

      endif

c  renmant of the photon with emitting a gluon is
        nrem = ipars(16)
c  quark-antiqaurk pair /FORCE/
        nrem = 1
cc gluon
cc      nrem  = 0


c  print out information
       write(6,690) 

c modeg = 1
      if(modeg.eq.1)then
       WRITE(6,101)
       write(6,150)neven
       WRITE(6,110)nprc
       WRITE(6,115)ecm
       write(6,120)-q2max
       write(6,125)-q2xmin
       write(6,130)flamd,nflav
       write(6,140)q02,q2min
       write(6,160)kzap
       if( nprc .eq. 2)then
         write(6,201)q2xmin,q2xmax
         write(6,211)zmin
       endif
      endif
 101   FORMAT(' Parton shower in  electron photon scattering'/
     & ,' (virtual photon and real photon process)')
 150   format(' event number =',I8)
 110   FORMAT(' real pro(ee):2, real pro.(e-gamma).:1',
     & 'parton distri.:0 ',I3)
 115   FORMAT(' total energy',G15.5)
 120   format(' maximum virtual mass squared of the photon  =',G15.5)
 125   format(' minimum virtual mass squared of the photon  =',G15.5)
 130   format(' QCD param.  Lambda=',G15.5,'  no. of flavor =',I5)
 140   format(' cutoff mass squared =',G15.5,' initial Q**2 =',G15.5)
 160   format(' argument of alpha-s is K^2(0) or Pt^2(1) :',I5)
 201   format(' minimum and maximum of virtual photon',2G15.5)
 211   format(' mini. ener. frac. of real photon in positron ', G15.5)

c modeg = 2
      if(modeg.eq.2)then
       WRITE(6,501)
       write(6,150)neven
       WRITE(6,510)nprc
       WRITE(6,115)ecm
       write(6,120)-q2max
       write(6,130)flamd,nflav
       write(6,140)q02,q2min
       write(6,160)kzap
       if(nprc .ge.1)then
       write(6,570)q2xmin,q2xmax
       endif
      endif
       if(lpoint.eq.1)write(6,*)'restrict one phtoton is point-like '
       if(lpoint.eq.2)write(6,*)'restrict two phtotons are point-like '
 501   FORMAT(' Parton shower in  two quasi-real photon process'/
     & ,' (in e+ e- scattering)')
 510   FORMAT(' real pro(ee):2, real pro.(gamma-gamma).:1',
     & 'pro.(gamma-gamma with fixed pt2):0 ',I3)
 570   format(' minimun and maximum of q2 ',G15.5,3X,G15.5)

      write(6,691)
c
      return

c
  690 format(//
     1 ' ************************************************************ '/
     1 ' *                                                          * '/
     1 ' *    G  G  P  S       (version 1.0 , 24 Nov. 1995 )        * '/
     1 ' *                                                          * '/
     1 ' *            An Event Generator for Gamma-Gamma Physics    * '/
     1 ' *                                                          * '/
     1 ' *    T.Munehisa, K.Kato, D.Perret-Gallix                   * '/
     1 ' *                                                          * '/
     1 ' ************************************************************ '/
     x )
  691 format(' ----- End of qcinpt'/)
      end
