
c----------------------------------------------------------------------
c main : ggps
c
c  Main program for the gamma-gamma scattering.
c  By T.Munehisa, K.Kato, D.Perret-Gallix
c
c  Updated on 95/11/24
c----------------------------------------------------------------------

c Monitor events for 1..iprev, and, once in iprsk events.
      parameter ( iprev = 5 , iprsk = 10000 )

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,accptx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm
      common/cross/sigma0,sigmax,sigma
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/modegg/modeg,neven
      dimension kstr(200),lstr(200),mstr(200),nastr(200)

c ------ major common areas in JETSET -------
      real*4 p,v,paru,parj,pmas,parf,vckm,brat
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
      COMMON/LUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/LUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/LUDAT3/MDCY(500,3),MDME(2000,2),BRAT(2000),KFDP(2000,5)
c  *** suppress pi-0 decay ***
      MDCY(LUCOMP(111),1)=0

c  input of parameters  
      open(5,file='ggps.dat')
      call jinput(5)
      close(5)
c
c  preparation for shower
      call qcprep

c  subroutine for analysis (initial)
      call anal(0)

c weight factors
      wght0 =0.0d0
      wght0x =0.0d0
      fail = 0.0d0

c mode flag and print flag for mkstr3
      mode = 0
      iprt = 0

      write(6,600)
c
c    ---------- START MAIN LOOP ----------
      do 1 i=1,neven

    5     continue

c  Generate an event (partons)
          call ggpsgo( nfail )

          if( nfail.eq.1 ) then
             fail = fail +1.0d0
             go to 5
          end if

          wght0 =wght0 + wght

c  Hadronization
          call mkstr3(mode,iprt,nstr,kstr,lstr,mstr,nastr,nret)
          if( nret.eq.1 ) write(6,*)' ********** fail in the color flow'
          call tolund(nstr,kstr,lstr,mstr,nastr,1)

c  Monitor events
          if( i .le. iprev .or. mod(i,iprsk).eq.0 ) then
             write( 6,605 ) i, wght
             call qclist
             call lulist(1)
          end if

c Error in hadronization ?
          if( MSTU(24).ne.0 ) then
            write(6,*) ' *** Error in JETSET, i=',i
            call qclist
            iprt = 1
            call mkstr3(mode,iprt,nstr,kstr,lstr,mstr,nastr,nret)
            call lulist(1)
          end if

c  subroutine for analysis (an event)
      call anal(1)
c
    1 continue
c    ---------- END MAIN LOOP ----------

      write(6,601)

      sigma = sigmax*wght0/(float(neven)+fail)
      write(6,610)sigma

c  subroutine for analysis (final)
      call anal(2)

      stop
  600 format(/' -------- START EVENTS LOOP'/)
  605 format(/' ===== EVENT=',i10,'  WEIGHT=',f15.5)
  601 format(/' -------- END EVENTS LOOP'/)
  610 format(' the total cross section =',G15.5,' pb')
      end
