
c----------------------------------------------------------------------
c main : ggps
c
c  Main program for the gamma-gamma scattering.
c  mainb2 : remove hadronization from mainb.
c  By T.Munehisa, K.Kato, D.Perret-Gallix
c
c  Updated on 95/11/24
c----------------------------------------------------------------------

c Monitor events for 1..iprev, and, once in iprsk events.
      parameter ( iprev = 5 , iprsk = 10000 )

      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP
      common/prcss/ecm,xbmin,nprc
      common/qcwght/wght0,fail,wght,accptx
      common/qcpar/roots,q2max,q02,q2min,flamd,qmass(10),nflav
      common/photon/alpha,rtx,rtpo,rtph,rtvm,nfl,nfvm
      common/cross/sigma0,sigmax,sigma
      common/prcgg/q2xmax,q2xmin,zmin,ame2,ecmx0,rtxmn,rtxx
      common/modegg/modeg,neven
cc    dimension kstr(200),lstr(200),mstr(200),nastr(200)

c  input of parameters  
      open(5,file='ggps.dat')
      call jinput(5)
      close(5)
c
c  preparation for shower
      call qcprep

c  subroutine for analysis (initial)
      call anal(0)

c weight factors
      wght0 =0.0d0
      wght0x =0.0d0
      fail = 0.0d0

c mode flag and print flag for mkstr3
      mode = 0
      iprt = 0

      write(6,600)
c
c    ---------- START MAIN LOOP ----------
      do 1 i=1,neven

    5     continue

c  Generate an event (partons)
          call ggpsgo( nfail )

          if( nfail.eq.1 ) then
             fail = fail +1.0d0
             go to 5
          end if

          wght0 =wght0 + wght

c  Monitor events
          if( i .le. iprev .or. mod(i,iprsk).eq.0 ) then
             write( 6,605 ) i, wght
             call qclist
          end if

c  subroutine for analysis (an event)
      call anal(1)
c
    1 continue
c    ---------- END MAIN LOOP ----------

      write(6,601)

      sigma = sigmax*wght0/(float(neven)+fail)
      write(6,610)sigma

c  subroutine for analysis (final)
      call anal(2)

      stop
  600 format(/' -------- START EVENTS LOOP'/)
  605 format(/' ===== EVENT=',i10,'  WEIGHT=',f15.5)
  601 format(/' -------- END EVENTS LOOP'/)
  610 format(' the total cross section =',G15.5,' pb')
      end
