c --------------------------------------------------------------
c tolund : Interface to JETSET 7.4
c          written by K.Kato   95/10/27
c          updated on 95/10/30  add ich6 control
c --------------------------------------------------------------
      subroutine tolund(nstr,kstr,lstr,mstr,nastr,ich6)
c
c /NOTE/ Parton shower program ... R*8 for floating number
c        JETSET  ... R*4
      real*8 partn

c /NOTE/ Particle code in Parton shower program 
c     u,d,s,c,b,t = 1,2,3,4,5,6   -->  u<-->d in JETSET
c     anti-q = negative
c     gluon  = 0   --> 21 in JETSET 
c     photon, e-, e+ = 22, 11, -11   == JETSET
c     primary vertex = 99  --> absent in JETSET

c  ich6 : INPUT : Flag for GGPS.
c                 When ich6=1,  check listp(6, ) to
c                 detect final state particles.
c                 For other cases, ich6=0.

c   Arrays in arguments
      dimension kstr(1),lstr(1),mstr(1),nastr(1)

c   Working array for lujoin
      dimension ijoin(100)

c   Working array for cross-reference between JETSET/qcevnt
      dimension nadr(200)
      
c Common area to record parton shower
      COMMON/qcevnt/partn(10,1000),listp(10,1000),NTOP

c store particles in the final state

      ip = 0
      pi = acos(-1.0)

      do 10 n=1,ntop

c final particle
        if ( listp(3,n).eq.0 .and.
     1       (  ich6.ne.1 .or.
     2         (ich6.eq.1.and.listp(6,n).gt.0) ) ) then
          ip = ip+1
          nadr(n) = ip

c particle code
          n1 = listp(1,n)
          kf = n1
          if( n1.eq.1  ) kf = 2
          if( n1.eq.-1 ) kf =-2
          if( n1.eq.2  ) kf = 1
          if( n1.eq.-2 ) kf =-1
          if( n1.eq.0  ) kf = 21

c energy-momentum
          e  = partn(7,n)
          eps = e*1.0e-8
          px = partn(4,n)
          py = partn(5,n)
          pz = partn(6,n)
          pxy= sqrt(px**2+py**2)
          p  = sqrt(px**2+py**2+pz**2)
          if ( p.lt.eps ) then
            theta = 0.0
          else
            theta = acos(pz/p)
          end if
          if ( pxy.lt.eps ) then
            phi = 0.0
          else
            phi = atan2( py,px )
            if( phi.lt.0.0 ) phi = phi+2.0*pi
          end if

c      === add one particle ===
          call lu1ent(ip,kf,e,theta,phi)
         
        end if

   10 continue

      if( nstr.le.0 ) return

      do 100 n=1,nstr

        njoin = lstr(n)

        do 50 j=1,njoin
          jx = nastr(mstr(n)+j-1)
          ijoin(j) = nadr(jx)
   50   continue
        
c    === join ===
        call lujoin(njoin,ijoin)

  100 continue

c    === hadronization ===
      call luexec

      return
      end
